#ifndef Animated_Icon_h
#define Animated_Icon_h

#include <FL/Fl_Box.H>
#include <FL/Fl_Pixmap.H>

class Animated_Icon : public Fl_Box {
public:
	Animated_Icon(int x, int y, int w, int h, const char *l = 0);
	~Animated_Icon();               // deletes the Fl_Pixmaps!

	void add(Fl_Pixmap *, float);   // add after current, make current

	void start();                   // start continuous display
	void stop();
	int running() const { return running_; }

	void set(int);                  // change to this one, no update
					// user must call redraw()
private:
	struct icon_list {
		Fl_Pixmap *icon;        // pixmap to draw
		float delay;            // how long to leave it up
		icon_list *next;
	};

	icon_list *first;
	icon_list *current;
	int running_;

	static void icon_cb(Animated_Icon *);
};

#endif
