#include <FL/Fl_Window.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl.H>
#include <FL/Fl_Toggle_Tree.H>
#include <FL/Fl_Return_Button.H>
#include <FL/Fl_Multiline_Input.H>
#include <FL/Fl_Menu.H>
#include <FL/folder_small.xpm>
#include <FL/file_small.xpm>
#ifdef WIN32
// #undef WIN32
#endif
#ifdef __WIN32__
#include <Windows32/Base.h>
#include <Windows32/Defines.h>
#include <Windows32/Structures.h>
#include <winsock.h>
#ifndef  uint
typedef unsigned int uint;
#endif
#ifndef boolean
typedef int boolean;
#endif
#endif
#include <vector>
#ifndef _WIN32
#include <iostream>
#endif
#include <iomanip>
#include <string>
#include <sqlplus.hh>
#include "client.h"

extern Fl_Multiline_Input *sql_command; extern char *pass;
extern void s_fl_alert (const char *fmt,...); extern void strip (string& s);

class db_tree {
vector<string> databases,tables,strings;
	static void  close (Fl_Widget *w,void *p) { w->hide(); delete w;}
	static void close_b (Fl_Return_Button *b,void *p) {Fl_Window *w = (Fl_Window *)p; w->hide(); delete w;}
	static void put_it(Fl_Widget* w,void* p){
		Fl_Toggle_Tree* t=(Fl_Toggle_Tree*) w; if (Fl::event_key()!=65259) return;
		if (!t->current()) return; if (sql_command->value()[0]) sql_command->insert(" ");
		char *s,*ptr=strdup(t->current()->label()); s=strchr(ptr,' '); if (s) *s='\0';
		if (t->current()->user_data()) {sql_command->insert((char *)(t->current()->user_data())); sql_command->insert(".");};
		sql_command->insert(ptr); 	free(ptr);
	}
public:
	db_tree (void) {
		Fl_Window *w = new Fl_Window(420,320,"MySQL Hierarchy"); w->callback((Fl_Callback *)close);
		Fl_Return_Button *bb = new Fl_Return_Button(0,300,w->w(),20,"Dismiss"); bb->callback((Fl_Callback *)close_b,w); bb->shortcut(0xff0d);
		Fl_Scroll *s = new Fl_Scroll(10,10,400,280);
		s->type(Fl_Scroll::VERTICAL);
		Fl_Toggle_Tree *t = new Fl_Toggle_Tree(10,10,400-s->scrollbar.w(),0);	unsigned int counter; t->callback(put_it); s->end();
		int widths[4] = {250,300,500,0};
		t->column_widths(widths); t->draw_lines(1); t->edit_on_reselect(0);
		Connection con(use_exceptions);
		try {
			con.real_connect ("",options->hostname.c_str(),options->username.c_str(),\
												(pass) ? pass : "",options->port,options->compress,options->int_timeout,options->socketname.c_str());
			Query query = con.query();
			query << "show databases";
			Result res = query.store(); if (!(res.size() && res.num_fields())) return;
			Result::iterator i;
			for (i = res.begin(); i != res.end(); i++) {
				Row row = *i; string str(row[0]); strip(str); if (str.length()) databases.insert(databases.end(),str);
			}
			if (!databases.size()) return;
			Fl_Pixmap* folderSmall=new Fl_Pixmap(folder_small);
			Fl_Pixmap* fileSmall  =new Fl_Pixmap(file_small);
			Fl_Toggle_Node* database,*table,*field;		
			for (counter=0;counter<databases.size();counter++) {
				con.select_db(databases[counter]);
				t->add_next(database=new Fl_Toggle_Node((char *)databases[counter].c_str(),1,folderSmall,NULL));
				query= con.query(); query << "show tables"; Result res = query.store();
				if (!(res.size() && res.num_fields())) continue;
				Result::iterator i; tables.clear();
				for (i = res.begin(); i != res.end(); i++) {
					Row row = *i;	string xx(row[0]);
					tables.insert(tables.end(),xx);
				}
				if (!tables.size()) continue;
				for (unsigned int j = 0; j < tables.size();j++) {
					strings.insert(strings.end(),tables[j]);
					if (j) t->add_next(table = new Fl_Toggle_Node((char *)strings[strings.size()-1].c_str(),1,folderSmall,(void *)databases[counter].c_str()));
					else t->add_sub(table = new Fl_Toggle_Node((char *)strings[strings.size()-1].c_str(),1,folderSmall,(void *)databases[counter].c_str())); 
					query = con.query();
					query << "describe " << tables[j] << "";
					res = query.store(); Result::iterator i;
					unsigned int columns = res.num_fields(),red=0,col; string str;
					MYSQL_RES	*ress = res.mysql_result(); MYSQL_ROW roww;
					for (i = res.begin(); i!=res.end();i++) {
						str = "";  roww = mysql_fetch_row(ress); if (!roww) break;
						long unsigned * lengths = mysql_fetch_lengths(ress);
						for (col = 0; col < columns; col++)  {
							if (roww[col]==NULL) roww[col]=" ";
							string xx(roww[col],lengths[col]);
							str += xx + " ";
						}
						strings.insert(strings.end(),str);
						if (red++) t->add_next(field=new Fl_Toggle_Node((char *)strings[strings.size()-1].c_str(),0,fileSmall,(void *)tables[j].c_str()));
						else t->add_sub(field=new Fl_Toggle_Node((char *)strings[strings.size()-1].c_str(),0,fileSmall,(void *)tables[j].c_str()));
					} t->close(table); t->traverse_up();
				} t->traverse_up();
			}
			s_fl_message("");
		} catch (BadQuery er){
			s_fl_alert ("Error: %s  %d", er.error.c_str(),con.errnum());
			return;
		} catch (BadConversion er) {
			return;
		}
		t->update_height(); w->resizable(t); 
		w->show(); while (w->visible()) Fl::wait();
	}
	~db_tree (void) {
		databases.clear();tables.clear();strings.clear();
	}
};

void  table_hier (Fl_Menu_*,void*)  {
	 if (!connected) return; db_tree db;
}

void  edit_table (Fl_Menu_*,void*)  {}
