#include <FL/Flv_Table.H>
#include <FL/Flve_Input.H>
#include <FL/Fl_Window.H>
#include <FL/fl_draw.H>
#include <FL/Fl_Pixmap.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Round_Button.H>
#include "bebac.h"
#include <sqlplus.hh>
#include <ctype.h>
extern string real_sql; extern enum ios::open_mode how_to_open; extern char *pass;
#define depth       18
#define minmin       5
#define fontsize    14
#define cache_size  1000u
#define malo 10000u
#define puno 1000000u
#define CELL_LIMIT 512
static string nulica("NULL");

extern void if_disconn (void); extern void Trim(char *s); extern void strip(string& s);
extern int is_it_in_string(string &,int); 	extern void Luce (char *source, int,  int, int);
extern void jpeg_draw(char *title, char *source, int size);
extern int  gif_draw (char *title, const unsigned char *source, int size);

typedef vector <string> string_vector; struct red_type { string_vector *s; int redosled; bool *nule;};
struct save_type { string_vector *s; int redni_broj; bool *nule;};
void sql_exit(Fl_Widget *w, void *p); class Sinisa_je_blesav;
struct sortying_type {
public:
	int column, asc;
	sortying_type(int c,int a) : column(c), asc(a) {}
};
static  void *jedan=(void *)1,  *dva=(void *)2,  *jedanaest=(void *)11, *dvanaest=(void *)12, *trinaest=(void *)13;  
static	Fl_Menu_Item menutable[] = {
	{"&First",	FL_ALT+FL_SHIFT+'f',0,0,0},
	{"&Previous",	FL_ALT+FL_SHIFT+'p',0,0,0},
	{"&Next",	FL_ALT+FL_SHIFT+'n', 0, 0,0 },
	{"&Last",	FL_ALT+FL_SHIFT+'l', 0, 0,FL_MENU_DIVIDER},
	{"&Save",	FL_ALT+FL_SHIFT+'s', 0, 0 ,0 },
	{"&Quit",	FL_ALT+'x', 0, 0,0},
	{0}}; 

static	Fl_Menu_Item menu_num[] = {
	{"&Total on column",0,0,jedan,0},
	{"&Avg   on column",0,0,dva,FL_MENU_DIVIDER},
	{"&Case insensitive search",0,0,dvanaest,0},
	{"&Next",FL_CTRL+'l',0,trinaest,FL_MENU_DIVIDER},
	{"&Nothing",0,0,0,0},
	{0}}; 

static	Fl_Menu_Item menu_str[] = {
	{"&Case insensitive search",0,0,dvanaest,0},
	{"&Case sensitive search",0,0,jedanaest,0},
	{"&Next",FL_CTRL+'l',0,trinaest,FL_MENU_DIVIDER},
	{"&Nothing",0, 0, 0,0 },
	{0}}; 


unsigned int sinisa_escape_string(char *to,const char *from,uint length) {
  const char *to_start=to;  const char *end;
  for (end=from+length; from != end ; from++)  {
    switch (*from) {
    case 0:				/* Must be escaped for 'mysql' */
      *to++= '\\';
      *to++= '0';
      break;
    case '\n':				
      *to++= '\\';
      *to++= 'n';
      break;
    case '\r':
      *to++= '\\';
      *to++= 'r';
      break;
    case '\"':
      *to++= '\\';
      *to++= '\"';
      break;
    case '\'':
      *to++= '\\';
      *to++= '\'';
      break;
    case '%':
      *to++= '\\';
      *to++= '%';
      break;
    case '_':
      *to++= '\\';
      *to++= '_';
      break;
    default:
      *to++= *from;
    }
  }
  *to=0;
  return (uint) (to-to_start);
}

unsigned int sinisa_unescape_string(char *to,string &s) {
	const char *from=s.c_str();
  char *to_start=to;  const char *end;
  for (end=from+s.length(); from != end ; from++)  {
		if (*from == '\\' && from+1 != end)
	  {
	    switch(*++from) {
	    case 'n':
	      *to++='\n';
	      break;
	    case 'r':
	      *to++ = '\r';
	      break;
	    case '0':
	      *to++= 0;			// Ascii null
	      break;
	    case '_':
	    case '%':
	      *to++= '\\';		// remember prefix for wildcard
	      /* Fall through */
	    default:
	      *to++ = *from;
	      break;
	    }
	  }
		else *to++ = *from;
  }
  *to=0;
  return (unsigned int) (to-to_start);
}


class SearchWin : public Fl_Window {
public:
	string str_search; bool  case_sen, word, cur_row;  Sinisa_je_blesav *parent; int column;
	Fl_Check_Button *b_case, *b_word; Fl_Round_Button *b_cur; Fl_Input *inp;
	SearchWin (Sinisa_je_blesav *p, string &s, bool  c, bool w, int col, int W, int h, char *str);
	~SearchWin(); 
};
void  Go_Search (Sinisa_je_blesav *p, string &s, bool  c, bool w, int col, int W, int h, char *str);

class Sinisa_je_blesav : public Flv_Table {
public:
	unsigned int int_cache_size, num_rows, columns, total_length; int search_column; bool case_sen,word_search,memory_save, jeli_nula;	string sql,str_search,prazna,the_one; Fl_Input *row_input;
	vector <red_type> vrednosti; vector <string> field_names; vector <int> field_types, field_lengths; vector <sortying_type> sorts;	Fl_Window *sql_win; int found_row, where_found; vector<save_type> cache;
	Fl_Menu_Item *menutable; Fl_Menu_Button *button; char title[65]; SearchWin *s_win; vector<string> footer_values; long long medju_int; double medju_float;
	Connection *con; char lldb[129];
	void put_search_string (string& s) {str_search=s;}
	void navigate (int r,int c) {
		if (r != row()) row(r);if (c != col()) col(c); 
		char buff[11]; sprintf( buff, "%d", r + 1 ); if (row_input) row_input->value(buff,strlen(buff));
	}
	int comp(unsigned short int s1, unsigned short int s2) {
		if (sorts.size()) {
			for (unsigned int i=0;i<sorts.size();i++) {
				sortying_type sort=sorts[i]; int type = field_types[sort.column]; 
				red_type red=vrednosti[s1]; string str1((*red.s)[sort.column]); bool prvi=red.nule[sort.column];
				red=vrednosti[s2]; string str2((*red.s)[sort.column]); bool drugi=red.nule[sort.column];
				if (prvi && drugi) {if (i==sorts.size()-1) return 0; else continue;} 
				if (prvi || drugi) {
					if (sort.asc) {
						if (drugi) return 1; else return -1;
					} else {
						if (prvi)  return 1; else return -1;
					}
				}
				switch (type) {
				case 0: {
					int int1=atoi(str1.c_str()); int int2=atoi(str2.c_str());
					if (int1==int2) {
						if (i==sorts.size()-1) return 0; else continue;
					}
					if (sort.asc) {
						if (int1 > int2) return 1; else return -1;
					} else {
						if (int1 < int2) return 1; else return -1;
					}
				}
				break;
				case 1: {
					double int1=atof(str1.c_str()); double int2=atof(str2.c_str());
					if (int1==int2) {
						if (i==sorts.size()-1) return 0; else continue;
					}
					if (sort.asc) {
						if (int1 > int2) return 1; else return -1;
					} else {
						if (int1 < int2) return 1; else return -1;
					}
				}
				break;
				default:
					if (str1 == str2) {
						if (i==sorts.size()-1) return 0; else continue;
					}
					if (sort.asc) {
						if (str1 > str2) return 1; else return -1;
					} else {
						if (str1 < str2) return 1; else return -1;
					}
					break;
				}
			}
		} else {
			if (vrednosti[s1].redosled == vrednosti[s2].redosled) return 0;
			if (vrednosti[s1].redosled  > vrednosti[s2].redosled) return 1;
			return -1;
		}
		return 0;
	}
	inline void ex ( unsigned short x, unsigned short y) {
		red_type tmp = vrednosti[x]; vrednosti[x] = vrednosti[y]; vrednosti[y] = tmp;
	}
#include "qsort1.cc"
	void do_sort(int column, int shift) {
		if (memory_save) return;
		unsigned int i; sortying_type *j; string str;
		if (shift && (sorts.size() < 2)) return; 
		if (!shift && sorts.size() && column != sorts[0].column) sorts.clear(); 
		for (i=0,j=sorts.begin();i<sorts.size();j++,i++)
			if (sorts[i].column == column) break;
		if (i<sorts.size()) {
			if (i) {
				if (!shift) return;
				else {
					if (sorts[i].asc) sorts[0].asc = 0; else sorts.erase(j);
				}
			} else {
				if (sorts[i].asc) sorts[0].asc = 0; else sorts.clear();
			}
		} else {
			sortying_type sort (column,1); sorts.insert(sorts.end(),sort);
		}
		qSort (0, (size_t) vrednosti.size()); 
		found_row = where_found = -1; redraw();
	}

  void check_box(int i) {
		navigate (i,col());
	}
  	
  void zajednicki_num (int column) {
		feature_add(FLVF_ROW_FOOTER); redraw(); unsigned int counter=0; medju_int = 0; medju_float=0.0; Row row;
		if (memory_save) {
			string ssql(sql); str_to_upr(ssql); string real_sql(sql);
			int ii = ssql.find(" FROM "); while ((ii != -1) && is_it_in_string(ssql,ii-1)) ii = ssql.find(" FROM ",++ii);
			if (ii == -1) {s_fl_alert("Eeror in a code, report to Sinisa !!"); rows(0); cols(0); return;}
			ssql = (string)"SELECT SUM("  + field_names[column] + ") " +  real_sql.erase(0,ii);
			try {
				Query query = con->query(); query << ssql; ResUse result = query.use();  row = result.fetch_row(); 
				string _str = row[0].get_string(); medju_int = atoi(_str.c_str());  medju_float = atof(_str.c_str()); s_fl_message("");
			} catch (BadQuery er) { 
				if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
					con->close(); connected = 0; if_disconn(); s_fl_alert("Server gone away !! %d", con->errnum());
				}
				else s_fl_alert("Error in a code, report to Sinisa : %s %d\n",er.error.c_str(),con->errnum());
				rows(0); cols(0); return;
			}
		} else {
			for (;counter<num_rows;counter++) {
				red_type red=vrednosti[counter]; string_vector *v=red.s; 
				string pom((*v)[column]); long long pom_int = atoi(pom.c_str()); medju_int += pom_int; double pom_float=atof(pom.c_str()); medju_float += pom_float;
			}
		}
  }
  void  total_col (int column, int type) {
		zajednicki_num(column); char buffer[55]; 
		if (type) sprintf(buffer,"Total: %f",medju_float); else sprintf(buffer,"Total: %Ld", medju_int);
		string pom(buffer); footer_values[column]= pom; damage(FL_DAMAGE_ALL);
	}
	void avg_col (int column, int type) {
		zajednicki_num(column); char buffer[55]; 
		if (type) sprintf(buffer,"Avg: %f",medju_float/(double)num_rows); else sprintf(buffer,"Avg: %Ld", medju_int/num_rows);
		string pom(buffer); footer_values[column]= pom; damage(FL_DAMAGE_ALL);
	}
	void case_search_col (int column, int type) {
		case_sen=true; word_search=false; found_row=-1; where_found=-1;
		if (s_win) s_win->make_current(); else Go_Search(this,str_search,case_sen,word_search,column,324,132,"Search case sensitive"); 
	}
	void search_col (int column, int type) {
		case_sen=false; word_search=false; found_row=-1; where_found=-1;
		if (s_win) s_win->make_current(); else Go_Search(this,str_search,case_sen,word_search,column,324,132,"Search case insensitive");
	}
	void next_col (void) {
		if (memory_save) return; int i; 
		if (search_column == -1) return; if (!str_search.length()) return; found_row =  -1;
		string zz(str_search); if (!case_sen) str_to_upr(zz); Fl::focus(this);
		unsigned int counter=row()+1; if (counter >= num_rows) counter=0;
		for (;counter<num_rows;counter++) {
			red_type red=vrednosti[counter]; string_vector *v=red.s; 
			string pom((*v)[search_column]); if (!case_sen) str_to_upr(pom);
			if ((i = pom.find(zz)) != -1) { found_row=counter; where_found = i;  navigate (counter,search_column); break; }
		}
		if (counter==num_rows) navigate(0,search_column);
	}

  void click_box(int column) {
		if (column < 0) return;  
		int shift = Fl::event_shift(); int ctrl  = Fl::event_ctrl();
		if (Fl::event_button1() && !ctrl && !Fl::event_button2() && !Fl::event_button3())
			do_sort(column,shift);
		else {
			Fl_Menu_Item* which_menu = (field_types[column] < 2) ? menu_num : menu_str;
			const Fl_Menu_Item* m = which_menu->popup(Fl::event_x(), Fl::event_y(), 0, 0, 0);
			int switching = (m) ? (int) m->user_data_ : 0; if (switching) search_column=column;
			switch (switching) {
			case  1:        total_col(column, field_types[column]);  break;
			case  2:          avg_col(column, field_types[column]);  break;
			case 11:  case_search_col(column, field_types[column]);  break;
			case 12:       search_col(column, field_types[column]);  break;
			case 13:         next_col(); break;
			case 0:
			default: break;
			}
		}
	}

  static void go_home (Fl_Box * w, void *p) {
		Sinisa_je_blesav *s = (Sinisa_je_blesav *)p; 
		s->navigate (0,s->col());
	}

  static void go_up (Fl_Box * w, void *p) {
		Sinisa_je_blesav *s = (Sinisa_je_blesav *)p; 
		if (s->row()==0) return; int ii = s->row()-1;
		s->navigate (ii,s->col());
	}

	static void go_down (Fl_Box * w, void *p) {
		Sinisa_je_blesav *s = (Sinisa_je_blesav *)p;  
		if (s->row()==s->num_rows-1) return; int ii = s->row() + 1;
		s->navigate (ii,s->col());
	}

	static void go_end  (Fl_Box * w, void *p) {
		Sinisa_je_blesav *s = (Sinisa_je_blesav *)p;  
		s->navigate (s->num_rows-1,s->col());
	}

	static void jump  (Fl_Input * w, void *p) {
		Sinisa_je_blesav *s = (Sinisa_je_blesav *)p;  
		unsigned int ii = atoi(w->value())-1;
		if ((ii < 0) || (ii > s->num_rows-1)) {
			s_fl_message ("Your input is invalid, because row %d is out of bounds !!\n",ii);
			return;
		}
		s->navigate (ii,s->col());
	}
	static void file_save(Fl_Button *xx, void *p) {
		Sinisa_je_blesav *s = (Sinisa_je_blesav *)p;
		int i = fl_file_dialog("Save Results",file_name,Fl_File_Dialog::APPEND | Fl_File_Dialog::SAVEMODE | Fl_File_Dialog::MESSAGES,0,0); how_to_open=(i>1000) ? ios::app : ios::trunc; 
		if (!file_name[0] || !i) return; 
		if (strcmp(filename_ext(file_name),".res")) filename_setext(file_name,".res");
		do_save_file(s->sql); 
	}

	static void glupost (Fl_Widget*w,void *p) {
		Fl_Menu_* mw = (Fl_Menu_*)w;
		int i = mw->value();
		switch (i) {
		case 0: go_home(NULL,p); break;
		case 1: go_up(NULL,p); break;
		case 2: go_down(NULL,p); break;
		case 3: go_end(NULL,p); break;
		case 4: file_save(NULL,p); break;
		case 5: sql_exit(NULL,((Fl_Widget *)p)->parent()); break;
		default: break;
		}
	}

	Sinisa_je_blesav (int x, int y, int w, int h, int n, int c,char *chars, string &s) : Flv_Table(x,y,w,h,title), sql(s), num_rows(n), columns(c),prazna(""), str_search(""), case_sen(false), word_search(false), search_column(-1)	{
		s_win=(SearchWin *)0; row_input = (Fl_Input *)0; strcpy(title,chars); found_row=-1; where_found = -1; memory_save=commands30->value();
		for (unsigned int counter=0;counter<columns;counter++) footer_values.insert(footer_values.end(),(string)"Sinisa");
		strip(sql); int_cache_size=cache_size; str_search=(string)""; search_column = -1; jeli_nula=false; 
	}

	~Sinisa_je_blesav(void) {
		field_names.clear(); field_types.clear();  field_lengths.clear();
		for (unsigned int i=0;i<vrednosti.size();i++) {
			string_vector *xx=vrednosti[i].s; xx->clear();  delete xx; delete[] vrednosti[i].nule;
		}
		vrednosti.clear();  sorts.clear(); if (s_win) { delete s_win;  s_win=0; } footer_values.clear(); if (memory_save) delete con;
		for (unsigned int iii=0;iii<cache.size();iii++) {
			string_vector *xx=cache[iii].s; xx->clear();  delete xx; delete[] cache[iii].nule;
		}
		cache.clear();
	}

	inline void cols2( int n )	{    cols(n);	}
	
	void get_style( Flv_Style &s, int R, int C )	{
		Flv_Table::get_style(s,R,C);					//	Get standard style
    if (R==row() && C==col())
			s.border(FLVB_OUTER_ALL);
		if (R<0 || C<0)	s.font( (Fl_Font)(s.font()|FL_BOLD)); //	Heading/Footing is bold
		if (R==-1 || C==-1) s.background((Fl_Color)206);
		if (R>-1 && C>-1)	s.background((R%2) ?  (Fl_Color)(FL_GRAY_RAMP+21) : FL_WHITE);
		// Dented current headers
		if (R==row() && C==-1)			s.frame(FL_THIN_DOWN_BOX);
		if (C==col() && R==-1)			s.frame(FL_THIN_DOWN_BOX);
		// Added so you can get the highlighted row
		if (R==row())			s.background((Fl_Color)(FL_GRAY_RAMP+17));
	}
	
	string& mem_save_no_cursor (int R, int C) {
		int counter=0, koji=0;
// First we check if it is in the cache
		counter = R - cache[0].redni_broj;
		if (counter >= 0 && counter <  cache.size()) {save_type red=cache[counter]; string_vector *v=red.s; jeli_nula=red.nule[C];	return (jeli_nula) ? nulica : (*v)[C];	}
// Second we see if num of rows has been changed !! Luck is on the side of cautious ;o|
		string ssql(sql); str_to_upr(ssql); string real_sql(sql);
		unsigned int	new_rows, ii = ssql.find(" FROM "); while ((ii != -1) && is_it_in_string(ssql,ii-1)) ii = ssql.find(" FROM ",++ii);
		if (ii == -1) {s_fl_alert("Eeror in a code, report to Sinisa !!"); rows(0); cols(0); return prazna;}
		real_sql = (string)"SELECT COUNT(*)  " + real_sql.erase(0,ii);
		try {
			Query query = con->query(); query << real_sql; Result result = query.store();
			Result::iterator iter = result.begin(); Row row = *iter; new_rows=row[0];  s_fl_message("");
		} catch (BadQuery er) { 
			if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
				con->close(); connected = 0; if_disconn(); s_fl_alert("Server gone away !! %d", con->errnum());
			}
			else s_fl_alert("Error in a code, report to Sinisa : %s %d\n",er.error.c_str(),con->errnum());
			rows(0); cols(0); return prazna;
		}
// Third we check whether new number of rows differs from the previous one
		if (new_rows != num_rows) {
			if (!new_rows) {s_fl_alert("Someone changed your tables so that new result set is empty ! \n"); rows(0); cols(0); return prazna;}
			num_rows = new_rows; rows(num_rows); if (num_rows < int_cache_size) int_cache_size=num_rows; 
			if (num_rows > int_cache_size) int_cache_size=num_rows; if (int_cache_size >= cache_size) int_cache_size=cache_size;
// Almost forgot to change a label in that case >O(
			{ sprintf(title,"Query conditions were met by %d rows.", num_rows);
			  label(title); damage(FL_DAMAGE_CHILD);}
		}
// Fourth we now put in some small heuristics to choose the optimal values, in order to minimize running queries
		int first_row = 0, how_much = int_cache_size / 2; 
		if ((R - how_much)< 0) {
			first_row = 0; how_much = int_cache_size; koji = R;
		} else if ((R + how_much) > num_rows) {
			how_much = int_cache_size; first_row = num_rows - how_much; koji = how_much - (num_rows - R);
		} else {
			first_row = R - how_much; koji = how_much;
		}
// Fifth, now we construct carefully a query with a limit
		ssql=sql; str_to_upr(ssql); real_sql=sql;
		ii=ssql.find(" LIMIT "); while ((ii != -1) && is_it_in_string(ssql,ii-1)) ii = ssql.find(" LIMIT  ",++ii);
		if (ii == -1) ii = ssql.length(); else  real_sql.erase(ii,-1);
		string strbuf; strbuf =  real_sql + " LIMIT "; char buf[33]; sprintf(buf,"%d,%d", first_row,int_cache_size);
		strbuf += (string)buf;
// Sixth, now we execute a bloody query !! But first release memory !!
		for (unsigned int iii=0;iii<cache.size();iii++) {
			string_vector *xx=cache[iii].s; xx->clear();  delete xx;
		}
		cache.clear();
		try {
			Query query = con->query(); query << strbuf; ResUse result = query.use();
// Seventh, we must even check that a number of columns has not changed !
			int new_columns= result.num_fields(); 
			if (new_columns != columns)  {s_fl_alert("Someone changed your tables !\nNew result set contains different number of columns\n"); rows(0); cols(0); return prazna;}
			for (unsigned int j = 0; j < int_cache_size;j++) {
				Row row = result.fetch_row();  if (!row) break;
				unsigned long *duzine = result.fetch_lengths();
				save_type s_red; s_red.s = new string_vector();  s_red.redni_broj=j + first_row;
				for (counter = 0; counter < columns; counter++) {
					char buff[1024]; ii = duzine[counter]; 
					if (ii > CELL_LIMIT) ii=CELL_LIMIT;
					if (field_types[counter] > 2)
						ii = sinisa_escape_string(buff,row[counter].c_str(),ii);
					else
						sprintf(buff,"%*s",ii,row[counter].c_str()); 
					buff[ii] = '\0'; string str_(buff,ii); s_red.s->insert(s_red.s->end(),str_); s_red.nule[counter] = row[counter].is_null();
// Eight : Let us finally get a string we need ....
					if (j == koji && counter == C) {jeli_nula=row[counter].is_null(); the_one=(jeli_nula) ? nulica : str_; }
				}
				cache.insert(cache.end(),s_red);
			}		 
			s_fl_message("");
		} catch (BadQuery er) { 
			if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
				con->close(); connected = 0; if_disconn(); s_fl_alert("Server gone away !! %d", con->errnum());
			}
			else s_fl_alert("Error in a code, report to Sinisa : %s %d\n",er.error.c_str(),con->errnum());
			rows(0); cols(0); return prazna;
		}
		return the_one;
	}

	string& get_value(int R, int C ) {
		if (C < 0) return prazna;
		if (R == -2) {
			if (footer_values[C] != "Sinisa") return footer_values[C]; else return prazna;
		} else {
			if (memory_save) return mem_save_no_cursor (R,C);
			else {
				red_type red=vrednosti[R]; string_vector *v=red.s; jeli_nula=red.nule[C];
				return (jeli_nula) ? nulica : (*v)[C];
			}
		}
		return prazna;
	}

	void draw_cell( int Offset, int &X, int &Y, int &W, int &H, int R, int C ) {
		Flv_Style s; char buf[13] = ""; string value_str; int i=where_found; ; unsigned int offset=0, x1 = 0, ww;
		get_style(s,R,C);	Flv_Table::draw_cell(Offset,X,Y,W,H,R,C);
		if (R==-1 && C==-1) return;
		if (R==-1 && C>-1)				//	Row header contains column names 
			value_str = field_names[C];
		else if (C==-1 && R>-1)	{ //	Column header 1, 2, 3... row numbers
			if (row() != R)
				sprintf( buf, "%d", R + 1 ); 
			else {
				fl_draw_symbol("@>", X-Offset+(W-10), Y+(H-10)/2, 15, 10,(Fl_Color)(FL_BLACK) );	return;
			} 
			value_str = (string)buf;
		}  else if ((R>-1 && C>-1) || (R==-2))		//	Normal cell blank
			value_str = get_value (R,C);
		if (!rows()) return;
		fl_draw(value_str.c_str(), X-Offset, Y, W, H, s.align());
		if (str_search.length() && (search_column == C) && (R > -1) &&(i != -1)) {
			string kuda(value_str), gde(str_search);
			if (!case_sen) { str_to_upr(kuda); str_to_upr(gde);}
			int j = kuda.find(gde); if (j ==  -1 ) return; i = j;
			if (fl_width(value_str.c_str(),str_search.length() + i)  > col_width(C)) {
				if ((row() != R) || (found_row != R) || (col() != C) || (field_types[C] < 2)) return;
				offset = i; i = 0; fl_color(s.background()); fl_rectf(X - Offset,Y,W,H);  
				fl_draw(value_str.c_str() + offset, X-Offset, Y, W, H, s.align());  
			}
 			ww = (unsigned int) fl_width (value_str.c_str() + i + offset,str_search.length()); 
			fl_color(FL_RED); fl_font( (Fl_Font)(s.font() | FL_BOLD),fl_size());
			string pokazi(value_str,offset + i,str_search.length()); 
			if (field_types[C] > 1) {
				if (i) x1 = (unsigned int) fl_width(value_str.c_str(),i);
				fl_draw (pokazi.c_str(),X - Offset + x1,Y,ww,H,FL_ALIGN_NOWRAP);
			} else {
				if (i) x1 = (unsigned int) fl_width(value_str.c_str()+i);
				fl_draw (pokazi.c_str(),X - Offset + W - x1,Y,ww,H,FL_ALIGN_NOWRAP);
			}
		}
	}

  static void table_callback(Sinisa_je_blesav *n, void *) {
		switch( n->why_event() )		{
		case FLVE_ROW_HEADER_CLICKED:
			n->click_box(n->col()); break;
		case FLVE_COL_HEADER_CLICKED:
      n->check_box(n->row()); break;
		case 0: // Standard call back
			break;
		}
	}

  int handle(int event)	{
		char buff[11]; sprintf( buff, "%d", row() + 1 ); if (row_input) row_input->value(buff,strlen(buff));
		if (event == FL_KEYBOARD) {
			switch(Fl::event_key())			{
			 case FL_F+2 :  start_edit(); break;
			case 'E':
			case 'e':
				if ((Fl::event_state() & FL_CTRL) == FL_CTRL )    {
					start_edit(); break;
				}
			case 'l':
			case 'L':
				if ((Fl::event_state() & FL_CTRL) == FL_CTRL )    {
					next_col();char buff[11]; sprintf( buff, "%d", row() + 1 ); if (row_input) row_input->value(buff,strlen(buff)); return 1;
				}
			default: return Flv_Table::handle(event);
				break;
			}
		}
		return Flv_Table::handle(event);
	}
  
	virtual void save_editor( Fl_Widget *e, int R, int C )  {}


  virtual void load_editor( Fl_Widget *e, int R, int C ) {
		char expressions[] = 	"-+*/%(),!{}&|";
		string value(get_value(R,C)); bool going_to_spread=true; int ii, strl, jjjj;
		if (jeli_nula) return;  
		char *ptr=NULL; 
		Connection con(use_exceptions); long unsigned int length;	
		if (value.length() > options->max_width && value.length() > 40) {
// fetch the entire column in it's full length !!
			if (value.length() > CELL_LIMIT) {
				if (!strncasecmp(sql.c_str(),"SELECT",6)) {
					string command_buf(sql), pomoc (sql) ; unsigned int i, umetnuti, gde_from, where;
					for (ii=0;ii<pomoc.length();pomoc[ii]=tolower(pomoc[ii]),ii++);
					ii = pomoc.find(" from "); while ((ii != -1) && is_it_in_string(pomoc,ii-1)) ii = pomoc.find(" from ",++ii);
					if (ii == -1) s_fl_alert("Parse error");
					else {
						gde_from=ii;
						where = pomoc.find(" where ",ii); while ((where != -1) && is_it_in_string(pomoc,where-1)) where = pomoc.find(" where ",++where);
						// where_clause group_clause having_clause order_clause limit_clause procedure_clause
						int order, group, limit,  procedure;
						order = pomoc.find(" order ",gde_from); while ((order != -1) && is_it_in_string(pomoc,order-1)) order = pomoc.find(" order ",++order);
						group = pomoc.find(" group ",gde_from); while ((group != -1) && is_it_in_string(pomoc,group-1)) group = pomoc.find(" group ",++group);
						limit = pomoc.find(" limit ",gde_from); while ((limit != -1) && is_it_in_string(pomoc,limit-1)) limit = pomoc.find(" limit ",++limit);
						procedure = pomoc.find(" procedure ",gde_from); while ((procedure != -1) && is_it_in_string(pomoc,procedure-1)) procedure = pomoc.find(" procedure ",++procedure);
						umetnuti = (order != -1) ? order : ( (group != -1) ? group : ( (limit != -1) ? limit : ((procedure != -1) ? procedure : sql.length())));
						if (where == -1) {
							command_buf.insert(umetnuti," where 1 and "); umetnuti += 13;
						}
						for (int i = 0,  jjjj = 0; i < columns; i++, jjjj++) {
							string xx(get_value(R,i));  
							for (strl = 0;expressions[strl];strl++) 
								if (field_names[i].find(expressions[strl]) != -1) break;
							if (expressions[strl]) { jjjj--; continue;}
							if (jeli_nula) { 
								if (i || where != -1) { command_buf.insert(umetnuti," and "); umetnuti += 5; } else {command_buf.insert(umetnuti,"  "); umetnuti += 2;}
								command_buf.insert(umetnuti,field_names[i]); umetnuti += field_names[i].length();   command_buf.insert(umetnuti," IS "); umetnuti += 4;
								command_buf.insert(umetnuti,nulica); umetnuti += nulica.length();
								continue;
							}
//						if (i == C && columns > 1) continue;
							if (i == C || (xx.length() > 20 && field_types[i] == 3)) {
								if (jjjj) { command_buf.insert(umetnuti," and "); umetnuti += 5; }
								command_buf.insert(umetnuti,field_names[i]); umetnuti += field_names[i].length();
								command_buf.insert(umetnuti," LIKE "); umetnuti += 6;
								command_buf.insert(umetnuti,"\""); umetnuti++;
								int gde=(i == C) ? 32 : 10; 
								while (xx[gde - 1] == '\\' && gde < xx.length()) gde++;
								if (gde >= xx.length()) {
									command_buf.insert(umetnuti,"%"); umetnuti++;
									command_buf.insert(umetnuti,"\""); umetnuti++;
									continue;
								}
								xx[gde]='%'; xx.erase(gde + 1);
								command_buf.insert(umetnuti,xx); umetnuti += xx.length();
								command_buf.insert(umetnuti,"\""); umetnuti++;
								continue;
							}
// Take declared field length and see if there is sense in doing it !!
							if (i || where != -1) { command_buf.insert(umetnuti," and "); umetnuti += 5; } else {command_buf.insert(umetnuti,"  "); umetnuti += 2;}
							command_buf.insert(umetnuti,field_names[i]); umetnuti += field_names[i].length();   command_buf.insert(umetnuti," = "); umetnuti += 3;
							if (field_types[i] > 1) {command_buf.insert(umetnuti,"\""); umetnuti++;}
							command_buf.insert(umetnuti,xx); umetnuti += xx.length();
							if (field_types[i] > 1) {command_buf.insert(umetnuti,"\""); umetnuti++;}
						}
						command_buf.erase(0,gde_from + 1);
						command_buf.insert(0,"SELECT    ");
						command_buf.insert(8,field_names[C]); 
						try {
							con.real_connect(lldb,options->hostname.c_str(),options->username.c_str(),(pass) ? pass : "",options->port,options->compress,options->int_timeout,options->socketname.c_str());
							Query query = con.query(); query << command_buf;
							Result  result = query.store();  Result::iterator iter = result.begin();
							if (!result.num_rows()) throw BadQuery("No rows"); Row row = *iter;
							((Flve_Input *)e)->value((value.c_str())); ((Flve_Input *)e)->position(((Flve_Input *)e)->size(), 0 );
							unsigned long int *lll=result.fetch_lengths();
							length = lll[0]; ptr=(char *)malloc(length);
							memcpy(ptr,(char *)row.raw_data(0),length);
							/* value = row[0].get_string(); */ going_to_spread=false; s_fl_message("");
// Check for escaping things !!!!!!!						
						} catch (BadQuery er) { 
							if ((con.errnum() > 2000) || (con.errnum() == 1043)) {
								s_fl_alert("Server gone away !! %d", con.errnum()); 
							}
							else s_fl_alert("This row does not exist anymore : %s %d\n",er.error.c_str(),con.errnum());
						}
					}
				}
			}
			else { 
				going_to_spread=false; 
				ptr=(char *)malloc(value.length());
				length = sinisa_unescape_string(ptr, value);
			}
		}
		if (going_to_spread) {
			string val(get_value(R,C));
			((Flve_Input *)e)->value((val.c_str())); ((Flve_Input *)e)->position(((Flve_Input *)e)->size(), 0 );
		}
		else {
			if (ptr[0] == '\xFF' && ptr[1] == '\xD8' && ptr[6] == 'J' && ptr[7] == 'F' && ptr[8] == 'I' && ptr[9] == 'F' ) {
				char tit[65]; sprintf (tit,"Zoom of JPEG from row %d, column %d", R+1, C+1);
				jpeg_draw(tit,ptr,(int)length);
			} else   if ((ptr[0] =='G' &&  ptr[1] =='I' &&  ptr[2] == 'F') && (ptr[3] =='8' || ptr[4] =='9' || ptr[5] == 'a') && length > 7) {
				char tit[65]; sprintf (tit,"Zoom of GIF  from row %d, column %d", R+1, C+1);
				if (gif_draw(tit,(const unsigned char *)ptr,(int)length)) 
					Luce(ptr,(int)length, R, C);
			} else	Luce(ptr,(int)length, R, C);
		}
		if (ptr) free(ptr); 
	}

	virtual void position_editor( Fl_Widget *e, int x, int y, int w, int h, Flv_Style &s)	{ if (jeli_nula) return;	Flv_Table::position_editor(e,x+s.x_margin(),y,w-s.x_margin(),h,s);	}
};

static void zatvaraj (Fl_Window *w,void *vvv) {	delete w;  w=(Fl_Window *)0;}

static void  cb_Find (Fl_Return_Button *rb, void *vvv) {
	SearchWin *the=(SearchWin *)vvv; int i; 
	if (the->str_search != (string)the->inp->value()) {the->parent->found_row = the->parent->where_found = -1;}
	the->str_search = (string)the->inp->value(); strip(the->str_search); if(!the->str_search.length()) return; the->str_search = (string)the->inp->value();  string zz(the->str_search); if (!the->b_case->value()) str_to_upr(zz);
	unsigned int counter=(the->b_cur->value()) ? the->parent->row()+1 : 0; if (counter==the->parent->num_rows) counter=0;
	the->parent->sql_win->make_current(); Fl::focus(the->parent);
	if (the->parent->memory_save) {
		for (counter=0;counter < the->parent->cache.size();counter++) {
			save_type red=the->parent->cache[counter]; string_vector *v=red.s; 
			string pom((*v)[the->column]); if (!the->b_case->value()) str_to_upr(pom);
			if (( the->parent->where_found = pom.find(zz)) != -1) {the->parent->found_row=the->parent->cache[counter].redni_broj; the->parent->navigate (the->parent->found_row,the->column); break;}
		}
	} else {
		for (;counter<the->parent->num_rows;counter++) {
			red_type red=the->parent->vrednosti[counter]; string_vector *v=red.s; 
			string pom((*v)[the->column]); if (!the->b_case->value()) str_to_upr(pom);
			if (( i  = pom.find(zz)) != -1) {the->parent->found_row=counter; the->parent->where_found = i; the->parent->navigate (counter,the->column); break;}
		}
		if (counter == the->parent->num_rows) the->parent->navigate (0,the->column);
	}
	the->parent->str_search = the->str_search; the->parent->case_sen = the->b_case->value(); the->parent->word_search = the->b_word->value();
	if (the->parent->memory_save) delete the;
}

SearchWin::SearchWin (Sinisa_je_blesav* p, string &s, bool  c, bool w, int col, int W, int h, char *str) : parent(p),  str_search(s), case_sen(c), word(w),column(col), cur_row(false), Fl_Window(W,h,str)  {}

void  Go_Search (Sinisa_je_blesav* p, string &s, bool  c, bool w, int col, int W, int h, char *str) {
	SearchWin *win = new SearchWin (p,s,c,w,col,W,h,str); win->color(197); win->callback((Fl_Callback *)zatvaraj);
	{ Fl_Input* o = win->inp = new Fl_Input(72, 6, 222, 25, "Search For");	o->labelsize(12);	o->textsize(12);	o->value(win->str_search.c_str());}
	{ Fl_Check_Button* o = win->b_case = new Fl_Check_Button(7, 34, 103, 25, "Match &Case"); o->down_box(FL_DIAMOND_DOWN_BOX); o->labelsize(12);	o->value(win->case_sen);}
	{ Fl_Check_Button* o  = win->b_word = new Fl_Check_Button(7, 55, 163, 25, "Match Whole &Word Only");				
	o->down_box(FL_DIAMOND_DOWN_BOX);		o->labelsize(12);		o->value(win->word);}
	{ Fl_Return_Button* o = new Fl_Return_Button(232, 102, 73, 25, "Find");	o->labelsize(12);	o->callback((Fl_Callback *)cb_Find,(void *)win); o->when(FL_WHEN_RELEASE);}
	{ Fl_Group* o = new Fl_Group(177, 45, 134, 51, "Search");	o->box(FL_EMBOSSED_FRAME);	o->labelsize(12);	o->align(FL_ALIGN_TOP_LEFT);
	  { Fl_Round_Button* o = win->b_cur = new Fl_Round_Button(179, 48, 115, 25, "From cur. row"); o->type(102);o->down_box(FL_ROUND_DOWN_BOX);
		o->labelsize(12); 	o->align(FL_ALIGN_RIGHT|FL_ALIGN_INSIDE); o->setonly();	}
		{ Fl_Round_Button* o = new Fl_Round_Button(179, 69, 115, 25, "Entire &Column");	o->type(102);
		o->down_box(FL_ROUND_DOWN_BOX);	o->labelsize(12);	o->align(FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);	}
		o->end();
	}
	win->parent->s_win=win; win->end(); win->show();
}

SearchWin::~SearchWin() {parent->s_win=0;parent->str_search=str_search; parent->case_sen=b_case->value();}
void sql_exit(Fl_Widget *w, void *p) {
	((Fl_Window*)p)->hide(); delete (Fl_Window *)p;
}

void do_sql() {
  Fl_Window *sql_window; Sinisa_je_blesav *scroller;
	unsigned int columns, counter, total_length=0,num_rows; 	int type;
  { Fl_Window*o = sql_window = new Fl_Window(640,480,"MySQL results");
	o->color(197);   o->selection_color(50);   o->labelfont(4);
    o->callback((Fl_Callback*)sql_exit,(void *)sql_window);
		if (w3_x && w3_y) 
			o->position(w3_x, w3_y);
		Connection *con = new Connection(use_exceptions);
		try {
			con->real_connect(ldb,options->hostname.c_str(),options->username.c_str(),(pass) ? pass : "",options->port,options->compress,options->int_timeout,options->socketname.c_str());
			Query query = con->query(); query << real_sql; ResUse result = query.use();  columns= result.num_fields(), num_rows=num_of_rows;
			{ char buffer[256]; sprintf(buffer,"Query conditions were met by %d rows.", num_rows);
		    scroller =   new Sinisa_je_blesav(0, 0, sql_window->w(), sql_window->h() - 60 , num_rows, columns, buffer,  real_sql); scroller->end();}
			scroller->con = con; strcpy(scroller->lldb,ldb);
			if (num_rows*columns < malo) scroller->memory_save=false; if (num_rows*columns > puno) scroller->memory_save=true;
			string ssql(scroller->sql); str_to_upr(ssql);
			if (!ssql.compare("SHOW",0,4) || !ssql.compare("DESCRIBE",0,6) || !ssql.compare("EXPLAIN",0,6)) scroller->memory_save=false;
			for  (counter=0;counter<columns;counter++) {
				mysql_type_info ttype=result.types(counter);
				MYSQL_RES *ress= result.mysql_result(); 	unsigned int length = ress->fields[counter].length; 
				if  (ttype == typeid(string) || ttype == typeid(Null<string>) || \
             ttype == typeid(Time) || ttype == typeid(Null<Time>) || \
             ttype == typeid(Date) || ttype == typeid(Null<Date>) || \
             ttype == typeid(DateTime) || ttype == typeid(Null<DateTime>)
            )
					type = 3;
				else if  ((ttype == typeid(short int)) || (ttype == typeid(int)) || (ttype == typeid(long int)) || (ttype == typeid(long long int)) || (ttype == typeid(unsigned short int)) || (ttype == typeid(unsigned int)) || (ttype == typeid( unsigned long int)) || (ttype == typeid(unsigned long long int)) || \
                  (ttype == typeid(Null<short int>)) || (ttype == typeid(Null<int>)) || (ttype == typeid(Null<long int>)) || (ttype == typeid(Null<long long int>)) || (ttype == typeid(Null<unsigned short int>)) || (ttype == typeid(Null<unsigned int>)) || (ttype == typeid( Null<unsigned long int>)) || (ttype == typeid(Null<unsigned long long int>))
                 )
					type = 0;
				else if  (ttype == typeid(float) || ttype == typeid(double) || ttype == typeid(Null<float>) || ttype == typeid(Null<double>))
					type = 1;
				else 
					type = 2;
				scroller->field_types.insert(scroller->field_types.end(),type);
				char buffer [101]; strcpy(buffer,result.names(counter).c_str());
				if (strlen(buffer) > length) length = strlen(buffer); 
				if (length < minmin) length = minmin; 
				if (length > options->max_width) length = options->max_width; if (strlen(buffer) > length) buffer[length-1] = '\0'; total_length += length;
				scroller->field_names.insert(scroller->field_names.end(),(string)buffer);
				scroller->field_lengths.insert(scroller->field_lengths.end(),length); 
			}
			for (unsigned int j = 0; j < num_rows;j++) {
				Row row = result.fetch_row();  if (!row) break;
				unsigned long *duzine = result.fetch_lengths();
				red_type red; save_type s_red; 
				if (!scroller->memory_save) {
					red.s = new string_vector(); red.redosled=j; red.nule = new bool[columns];
				} else {
					s_red.s = new string_vector();  s_red.redni_broj=j; s_red.nule = new bool[columns];
				}
				for (counter = 0; counter < columns; counter++) {
					char buff[1025]; int ii = duzine[counter]; 
					if (ii > CELL_LIMIT) ii=CELL_LIMIT;
					if (scroller->field_types[counter] > 2)
						ii = sinisa_escape_string(buff,row[counter].c_str(),ii);
					else
						sprintf(buff,"%*s",ii,row[counter].c_str()); 
					buff[ii] = '\0';  string str_(buff,ii);  
					if (scroller->memory_save) s_red.s->insert(s_red.s->end(),str_); else red.s->insert(red.s->end(),str_);
					if (scroller->memory_save) s_red.nule[counter] = row[counter].is_null(); else red.nule[counter] = row[counter].is_null();
				}
				if (scroller->memory_save) scroller->cache.insert(scroller->cache.end(),s_red); else scroller->vrednosti.insert(scroller->vrednosti.end(),red); 
				if (scroller->memory_save && j == cache_size - 1) break;
			}
			s_fl_message("");
		} catch (BadQuery er) { 
			if (sql_window) delete sql_window;
			s_fl_alert(er.error.c_str()); s_fl_alert("\n");
			if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
				con->close(); connected = 0; if_disconn();
			}
			if (!scroller->memory_save) delete con;  return;
		}
		if (!scroller->memory_save) delete con;
		scroller->button = new Fl_Menu_Button(0,0,sql_window->w(),sql_window->h()); scroller->callback((Fl_Callback*)scroller->table_callback,scroller);
		(scroller->button)->type(4); (scroller->button)->labeltype(FL_NO_LABEL); (scroller->button)->textfont(9); scroller->sql_win=sql_window;
		(scroller->button)->menu(menutable); (scroller->button)->callback((Fl_Callback*)scroller->glupost,scroller);
		scroller->rows(num_rows);scroller->cols2(columns);
		scroller->has_scrollbar(FLVS_BOTH);
		scroller->feature(FLVF_DIVIDERS|FLVF_HEADERS|FLVF_ROW_ENDS|FLVF_PERSIST_SELECT); scroller->feature_remove(FLVF_ROW_FOOTER);
		scroller->row_style[-1].resizable(true); scroller->col_style[-1].resizable(true);
		scroller->global_style.align(FL_ALIGN_LEFT); 		scroller->global_style.background((Fl_Color)197);
		scroller->global_style.font_size(fontsize); scroller->row_style[-2].font_size(12);
		scroller->col_style[-1].width(int(fl_width("12345678"))); scroller->col_style[-1].align(FL_ALIGN_CENTER); scroller->row_style[-1].align(FL_ALIGN_CENTER);scroller->row_style[-2].align(FL_ALIGN_CENTER);
		scroller->global_style.height(depth);
		if (options->font_number!=-1) scroller->global_style.font((Fl_Font)options->font_number);
		for (unsigned int j = 0; j < columns; j++) {
			if (scroller->field_types[j] < 2)
				scroller->col_style[j].align(FL_ALIGN_RIGHT);
			else 
				scroller->col_style[j].align(FL_ALIGN_LEFT);
			scroller->col_style[j].clear_width();
      int len = scroller->field_lengths[j];
			string x((len<20) ? len :  20+(len-20)/2,'W');
			len = (int) fl_width(x.c_str());
			scroller->col_style[j].width(len);
			scroller->col_style[j].resizable(true);
		}
		scroller->global_style.border(FLVB_INNER_ALL);				//	On left of last column
		scroller->global_style.border_color(FL_BLACK);	
		scroller->global_style.x_margin(5);
		scroller->global_style.locked(false);
		scroller->global_style.width(100);
		scroller->row_style[FLV_TITLE].cell_style[0].align(FL_ALIGN_CENTER); 
		Flve_Input *j_e = new Flve_Input( 0, 0, 0, 0 ); j_e->owner = scroller; 	j_e->textsize(fontsize);
		scroller->edit_when(FLV_EDIT_AUTOMATIC); scroller->global_style.editor(j_e);
		int kude=sql_window->h()-40;
		{ Fl_Box* o = new Fl_Box(10, kude, 25, 25, "@|<");
	  o->box(FL_UP_BOX); o->labeltype(FL_SYMBOL_LABEL); o->labelfont(4);
		o->labelsize(10); o->labelcolor(81);
		Fl_Button *obj = new Fl_Button(10,kude,25,25); obj->type(FL_HIDDEN_BUTTON);
		obj->callback((Fl_Callback*)scroller->go_home,(void *)scroller); 	obj->when(6);
		}
		{ Fl_Box* o = new Fl_Box(35, kude, 25, 25, "@<");
	  o->box(FL_UP_BOX); o->labeltype(FL_SYMBOL_LABEL); o->labelfont(4);
		o->labelsize(10); o->labelcolor(39);
		Fl_Button *obj = new Fl_Button(35,kude,25,25); obj->type(FL_HIDDEN_BUTTON);
		obj->callback((Fl_Callback*)scroller->go_up,(void *)scroller); 	obj->when(6);
		}
		{ Fl_Input* o = scroller->row_input = new Fl_Input(60, kude, 100, 25);
	  o->type(2); o->box(FL_BORDER_BOX); o->selection_color(7);
		o->textfont(5); o->textcolor(177);
		o->callback((Fl_Callback*)scroller->jump,(void *)scroller);
		o->when(8); o->value("1");
		}
		{ Fl_Box* o = new Fl_Box(160, kude, 25, 25, "@>");
	  o->box(FL_UP_BOX); o->labeltype(FL_SYMBOL_LABEL);
		o->labelfont(4); o->labelsize(10); o->labelcolor(39);
		Fl_Button *obj = new Fl_Button(160,kude,25,25); obj->type(FL_HIDDEN_BUTTON);
		obj->callback((Fl_Callback*)scroller->go_down,(void *)scroller); 	obj->when(6); 
		}
		{ Fl_Box* o = new Fl_Box(185, kude, 25, 25, "@>|");
	  o->box(FL_UP_BOX);
		o->labeltype(FL_SYMBOL_LABEL); o->labelfont(4); o->labelsize(10); o->labelcolor(81);
		Fl_Button *obj = new Fl_Button(185,kude,25,25); obj->type(FL_HIDDEN_BUTTON);
		obj->callback((Fl_Callback*)scroller->go_end,(void *)scroller); 	obj->when(6);
		}
		{ Fl_Button* o  = new Fl_Button(260, kude-5, 130, 35, "Save to file");
	  o->down_box(FL_DOWN_BOX); o->labeltype(FL_EMBOSSED_LABEL); o->labelfont(8);
		o->labelsize(18); o->labelcolor(177);      o->align(16);
		o->callback((Fl_Callback*)scroller->file_save,(void *)scroller);
		}
		{ Fl_Button* o  = new Fl_Button(440, kude-5, 120, 35, "Exit");
	  o->down_box(FL_DOWN_BOX); o->shortcut(0xff1b);
		o->labeltype(FL_EMBOSSED_LABEL); o->labelfont(8);
		o->labelsize(18); o->labelcolor(177); o->align(16);
		o->callback((Fl_Callback*)sql_exit,(void *)sql_window);
		}
		o->resizable(scroller); o->end();	o->show();
  }
}
