#include <FL/Fl.H>
#include <FL/Fl_Toggle_Tree.H>
#include <FL/folder_small.xpm>
#include <FL/file_small.xpm>
#ifdef WIN32
// #undef WIN32
#endif
#ifdef __WIN32__
#include <Windows32/Base.h>
#include <Windows32/Defines.h>
#include <Windows32/Structures.h>
#include <winsock.h>
#ifndef  uint
typedef unsigned int uint;
#endif
#ifndef boolean
typedef int boolean;
#endif
#endif
#include <vector>
#ifndef _WIN32
#include <iostream>
#endif
#include <iomanip>
#include <string>
#include <sqlplus.hh>

#define REFRESH_GRANT		1	/* Refresh grant tables */
#define REFRESH_LOG		2	/* Start on new log file */
#define REFRESH_TABLES		4	/* close all tables */
#define REFRESH_HOSTS		8	/* Flush host cache */
#define REFRESH_STATUS		16	/* Flush status variables */
#define REFRESH_FAST		32768	/* Intern flag */

#include "grant.h"
#include "client.h"

extern char *pass;  extern void if_disconn(void); extern Connection *con;
static Fl_Box *MySQLLogo=(Fl_Box *)0;

#include <FL/Fl_Pixmap.H>
extern  char *image_mysql_do_sql[];

static Fl_Pixmap pixmap_mysql_do_sql(image_mysql_do_sql);
	

class grant_tree : public Fl_Window {
	Fl_Group *commands_group;
	Fl_Check_Button *b_grant, *b_revoke;
	Fl_Input *i_user, *i_host;
	Fl_Light_Button *b_all, *b_select, *b_insert, *b_update, *b_delete, *b_references, *b_usage, *b_index, *b_alter, *b_create, *b_drop, *b_reload, *b_shutdown, *b_process, *b_file, *b_grantt;
	Fl_Scroll *scroll_g_r;
	Fl_Return_Button *b_OK;
	Fl_Button *b_cancel; Fl_Toggle_Tree *tree; Fl_Output *out;

	void cb_b_cancel(void) {
		hide(); delete this;
	}
	void cb_b_grant(void) {
		if (b_revoke->value()) b_grant->value(0); else b_grant->value(1);
		b_grantt->activate();
	}
	void cb_b_revoke(void) {
		if (b_grant->value()) b_revoke->clear(); else b_revoke->set();
		b_grantt->value(0); b_grantt->deactivate();
	}
	void cb_b_all(void) {
		if (b_all->value()) commands_group->deactivate(); else commands_group->activate();
	}

	vector<string> databases,tables,strings; string exchange_buff;
	void put_it(void)   {
		Fl_Toggle_Tree* t=(Fl_Toggle_Tree*) tree; // if (Fl::event_key()!=65259) return;
		if (!t->selected()) return; 
		exchange_buff = (string)"";
		char *s=NULL,*ptr=strdup(t->selected()->label()); 
		s=strchr(ptr,' '); if (s) *s='\0'; 
		if (t->selected()->user_data()) {exchange_buff += (string)((char *) t->selected()->user_data()); exchange_buff += (string)".";} 
		exchange_buff += (string)ptr;
		free(ptr); out->value(""); out->value(exchange_buff.c_str());
	}
	static void s_cb_b_cancel(Fl_Button*, void*p) {
		grant_tree *sstatic = (grant_tree *)p;
		sstatic->cb_b_cancel();
	}
	static void s_cb_b_grant(Fl_Check_Button*, void*p) {
		grant_tree *sstatic = (grant_tree *)p;
		sstatic->cb_b_grant();
	}
	static void s_cb_b_revoke(Fl_Check_Button*, void*p) {
		grant_tree *sstatic = (grant_tree *)p;
		sstatic->cb_b_revoke();
	}
	static void s_cb_b_all(Fl_Light_Button*, void*p) {
		grant_tree *sstatic = (grant_tree *)p;
		sstatic->cb_b_all();
	}
	static void s_put_it(Fl_Widget* w,void* p){
		grant_tree *sstatic = (grant_tree *)p;
		sstatic->put_it();
	}
	void do_ok(void) {
		if (!exchange_buff.length()) {adm_ispis = 1; s_fl_alert("You need to choose that ON which grant is given !"); return;}
		string grant_str; grant_str = (b_grant->value()) ? (string)"GRANT " : (string)"REVOKE "; int prvi_put = 1, global = 0, dots= 0;
		if (exchange_buff==(string)"GLOBAL") { global = 1; exchange_buff=(string)"*.*";} 
		else {for (unsigned int i=0;i<exchange_buff.length();i++) if (exchange_buff[i]=='.') dots++;}
		string user(i_user->value()), host(i_host->value());
		strip (user); strip (host); 
		if (!user.length()) {adm_ispis = 1; s_fl_alert(" You have to enter user name !"); return;}
		if (!host.length()) {adm_ispis = 1; s_fl_alert(" You have to enter name of the host !"); return;}
		user += (string)"@" + host;
		if (b_all->value()) grant_str += (string)"ALL PRIVILEGES ";
		else {
			if (b_select->value()) { if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"SELECT";}
			if (b_insert->value())  { if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"INSERT";}
			if (b_update->value())  { if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"UPDATE";}
			if (b_delete->value())  { if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"DELETE";}
			if (b_references->value())  {adm_ispis = 1; s_fl_alert("References  privilege can be used on column  level only"); return; }
			if (b_usage->value())  {  if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"USAGE";}
			if (b_index->value())  { if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"INDEX";}
			if (b_alter->value())  { if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"ALTER";}
			if (b_create->value())  {  if (dots) {adm_ispis = 1; s_fl_alert("Create   privilege can be assigned on database level only"); return;} if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"CREATE";}
			if (b_drop->value())  { if (dots) {adm_ispis = 1; s_fl_alert("Drop  privilege can be assigned on database level only"); return;} if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"DROP";}
			if (b_reload->value())  { if (!global) {adm_ispis = 1; s_fl_alert("Reload privilege can be assigned on global level only"); return;} if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"RELOAD";}
			if (b_shutdown->value())  {if (!global) {adm_ispis = 1; s_fl_alert("Shutdown privilege can be assigned on global level only"); return;} if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"SHUTDOWN";}
			if (b_process->value())  {if (!global) {adm_ispis = 1; s_fl_alert("Process  privilege can be assigned on global level only"); return;} if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"PROCESS";}
			if (b_file->value())  {if (!global) {adm_ispis = 1; s_fl_alert("File  privilege can be assigned on global level only"); return;} if (prvi_put) prvi_put = 0; else grant_str += ", ";  grant_str += (string)"FILE";}
		}
		if (prvi_put && !b_all->value()) {adm_ispis = 1; s_fl_alert(" You have to choose at least one of the privileges !"); return;}
		if (!dots) exchange_buff += (string) ".* ";
		grant_str = grant_str + (string) " ON " + exchange_buff + ((b_revoke->value()) ? (string) " FROM " : (string) " TO ") + user + ((b_grantt->value()) ? (string) " WITH GRANT OPTION" : (string) "");
		Connection con(use_exceptions);
		try {
			con.real_connect ("",options->hostname.c_str(),options->username.c_str(),\
												(pass) ? pass : "",options->port,options->compress,options->int_timeout,options->socketname.c_str());
			Query query = con.query();  
			query.execute(grant_str.c_str());
			adm_ispis = 1; s_fl_message(con.info().c_str()); s_fl_message("\n");
			adm_ispis = 1; s_fl_message("%s for user %s succeeded",b_revoke->value() ? "REVOKE" : "GRANT", user.c_str());
		} catch (BadQuery er){
			adm_ispis = 1; s_fl_alert("Error in making a grant statement: %s %d ",er.error.c_str(), con.errnum()); return;
		} catch (BadConversion er) {
			adm_ispis = 1; s_fl_alert ("Error: Tried to make impossible conversion"); return;
		}	
		if (this) {hide(); delete this;}
	}
	static void s_do_ok(Fl_Button*, void*p) {
		grant_tree *sstatic = (grant_tree *)p;
		sstatic->do_ok();
	}
public:
  void cb_w_grant(void) {
		hide(); delete this;
	}
  grant_tree (int w, int h, char *l) : Fl_Window (w,h,l) {
	  { Fl_Group* o = new Fl_Group(15, 0, 190, 80, "Choose :"); exchange_buff=(string)"";
      o->labelfont(1); o->labelcolor(59);  o->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE); o->when(FL_WHEN_NEVER);
      { Fl_Check_Button* o = b_grant = new Fl_Check_Button(90, 5, 35, 35, "  GRANT");
        o->type(102); o->down_box(FL_DIAMOND_DOWN_BOX); o->value(1);  o->selection_color(3);
        o->labelfont(9);o->labelcolor(59);  o->user_data(this); o->callback((Fl_Callback*)s_cb_b_grant);   o->when(FL_WHEN_RELEASE);
      }
      { Fl_Check_Button* o = b_revoke = new Fl_Check_Button(90, 35, 40, 35, " REVOKE");
        o->type(102); o->down_box(FL_DIAMOND_DOWN_BOX); o->selection_color(3);  o->labelfont(9);
        o->labelcolor(59); o->user_data(this);  o->callback((Fl_Callback*)s_cb_b_revoke); o->when(FL_WHEN_RELEASE);
      }
      o->end();
    }
    { Fl_Input* o = i_user = new Fl_Input(305, 10, 200, 25, "User name : ");
      o->selection_color(50);o->labelfont(1); o->labelcolor(59);
      o->textfont(5); o->textcolor(177); o->when(FL_WHEN_NEVER);
    }
    { Fl_Input* o = i_host = new Fl_Input(305, 40, 340, 25, "Host name : ");
      o->selection_color(50); o->labelfont(1); o->labelcolor(59);
      o->textfont(5);o->textcolor(177); o->when(FL_WHEN_NEVER);
    }
    { Fl_Box* o = new Fl_Box(15, 85, 170, 440);
      o->box(FL_ENGRAVED_BOX);
    }
    { Fl_Light_Button* o = b_all = new Fl_Light_Button(30, 95, 140, 25, " ALL");
      o->down_box(FL_DOWN_BOX); o->value(1); o->labeltype(FL_ENGRAVED_LABEL); o->labelfont(9);
      o->labelsize(16);  o->labelcolor(121);  o->user_data(this); o->when(FL_WHEN_RELEASE); o->callback((Fl_Callback*)s_cb_b_all);  o->set();
    }
    { Fl_Group* o = commands_group = new Fl_Group(30, 130, 140, 350);
      o->color(50); o->selection_color(50);  o->labeltype(FL_NO_LABEL);
      { Fl_Light_Button* o = b_select = new Fl_Light_Button(30, 130, 140, 25, " SELECT");
        o->down_box(FL_DOWN_BOX);  o->selection_color(2); o->labelfont(9);  o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_insert = new Fl_Light_Button(30, 155, 140, 25, " INSERT");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_update = new Fl_Light_Button(30, 180, 140, 25, " UPDATE");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_delete = new Fl_Light_Button(30, 205, 140, 25, " DELETE");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_references = new Fl_Light_Button(30, 230, 140, 25, " REFERENCES");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_usage = new Fl_Light_Button(30, 255, 140, 25, " USAGE");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_index = new Fl_Light_Button(30, 280, 140, 25, " INDEX");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_alter = new Fl_Light_Button(30, 305, 140, 25, " ALTER");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_create = new Fl_Light_Button(30, 330, 140, 25, " CREATE");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_drop = new Fl_Light_Button(30, 355, 140, 25, " DROP");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_reload = new Fl_Light_Button(30, 380, 140, 25, " RELOAD");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_shutdown = new Fl_Light_Button(30, 405, 140, 25, " SHUTDOWN");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_process = new Fl_Light_Button(30, 430, 140, 25, " PROCESS");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      { Fl_Light_Button* o = b_file = new Fl_Light_Button(30, 455, 140, 25, " FILE");
        o->down_box(FL_DOWN_BOX); o->selection_color(2); o->labelfont(9); o->labelcolor(59);
      }
      o->deactivate();
      o->end();
    }
    { Fl_Light_Button* o = b_grantt = new Fl_Light_Button(30, 490, 140, 25, " GRANT");
      o->down_box(FL_DOWN_BOX); o->selection_color(6); o->labelfont(9); o->labelcolor(177);
    }
    { Fl_Return_Button* o = b_OK = new Fl_Return_Button(270, 410, 120, 35, "OK");
      o->down_box(FL_DOWN_BOX); o->shortcut(0xff0d); o->labeltype(FL_ENGRAVED_LABEL);
      o->labelfont(8); o->labelsize(18); o->labelcolor(69);  o->user_data(this); o->callback((Fl_Callback*)s_do_ok);
      o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    }
    { Fl_Button* o = b_cancel = new Fl_Button(465, 410, 120, 35, "Cancel");
      o->down_box(FL_DOWN_BOX); o->shortcut(0xff1b); o->labeltype(FL_ENGRAVED_LABEL);
      o->labelfont(8); o->labelsize(18); o->labelcolor(177);
       o->user_data(this); o->callback((Fl_Callback*)s_cb_b_cancel);
      o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    }
    { Fl_Box* o = MySQLLogo = new Fl_Box(390, 470, 85, 30);
      pixmap_mysql_do_sql.label(o);
    }

    Fl_Scroll *s = new Fl_Scroll(230, 85, 400, 280);  s->type(Fl_Scroll::VERTICAL_ALWAYS);  s->box(FL_THIN_DOWN_FRAME);

		Fl_Toggle_Tree *t = new Fl_Toggle_Tree(232,87,400 - s->scrollbar.w(),10); s->end(); tree=t;
		unsigned int counter; t->user_data(this); t->callback(s_put_it);
		int widths[4] = {300,400/*,500*/,0};  
		t->column_widths(widths); t->draw_lines(0);  t->edit_on_reselect(0);
		Connection con(use_exceptions);
		try {
			con.real_connect ("",options->hostname.c_str(),options->username.c_str(),\
												(pass) ? pass : "",options->port,options->compress,options->int_timeout,options->socketname.c_str());
			Query query = con.query();
			query << "show databases";
			Result res = query.store(); if (!(res.size() && res.num_fields())) return;
			Result::iterator i;
			for (i = res.begin(); i != res.end(); i++) {
				Row row = *i; string str(row[0]); strip(str); if (str.length()) databases.insert(databases.end(),str);
			}
			if (!databases.size()) return;
			Fl_Pixmap* folderSmall=new Fl_Pixmap(folder_small);
			Fl_Pixmap* fileSmall  =new Fl_Pixmap(file_small); t->add_next("GLOBAL",0,folderSmall,(void *)"global"); 
			Fl_Toggle_Node* database,*table,*field;		
			for (counter=0;counter<databases.size();counter++) {
				con.select_db(databases[counter]);
				if (counter) t->add_next(database=new Fl_Toggle_Node((char *)databases[counter].c_str(),0,folderSmall,NULL));
				else t->add_sub(database=new Fl_Toggle_Node((char *)databases[counter].c_str(),0,folderSmall,NULL));
				query= con.query(); query << "show tables"; Result res = query.store();
				if (!(res.size() && res.num_fields())) continue;
				Result::iterator i; tables.clear();
				for (i = res.begin(); i != res.end(); i++) {
					Row row = *i;	string xx(row[0]);
					tables.insert(tables.end(),xx);
				}
				if (!tables.size()) continue;
				for (unsigned int j = 0; j < tables.size();j++) {
					strings.insert(strings.end(),tables[j]);
					if (j) t->add_next(table = new Fl_Toggle_Node((char *)strings[strings.size()-1].c_str(),0,folderSmall,(void *)databases[counter].c_str()));
					else t->add_sub(table = new Fl_Toggle_Node((char *)strings[strings.size()-1].c_str(),0,folderSmall,(void *)databases[counter].c_str())); 
				} t->traverse_up();
			}
			s_fl_message("");
		} catch (BadQuery er){
			adm_ispis = 1; s_fl_alert ("Error: %s  %d", er.error.c_str(),con.errnum());
			return;
		} catch (BadConversion er) {
			return;
		}
		t->update_height(); resizable(*t);
    out = new Fl_Output(230, 370, 400, 30);
		out->box(FL_DOWN_BOX);  out->textsize(14);out->color(50);  out->labelfont(9);   out->labelcolor(177);  out->textfont(8);      out->align(FL_ALIGN_LEFT);

  }
	~grant_tree (void) {databases.clear();tables.clear();strings.clear();};
};

static void s_cb_w_grant(Fl_Window*, void*p) {
  grant_tree *sstatic = (grant_tree *)p;
  sstatic->cb_w_grant();
}


void grant_revoke(Fl_Menu_*m,void *s) {
  if (!connected) return;  
  grant_tree  *w = new grant_tree (656, 535, "Grant/Revoke"); 
  w->color(50); w->selection_color(50); w->labeltype(FL_NORMAL_LABEL); w->labelfont(4);  w->user_data(w); w->callback((Fl_Callback*)s_cb_w_grant);
  w->show();  while (w->visible()) Fl::wait();
}

void grant_revoke_b(Fl_Button *m,void *s) {
  if (!connected) return; 
  grant_revoke(NULL,NULL);
}

void m_shutdown(Fl_Menu_*m,void *s) {
  if (!connected) return; 
	try {
		con->shutdown(); 		adm_ispis = 1; s_fl_message("shutdown succeeded'"); if_disconn();
	} catch (BadQuery er){
		adm_ispis = 1; s_fl_alert("shutdown failed; error:: %s %d ",er.error.c_str(), con->errnum()); return;
	}
}

void refresh(Fl_Menu_*m,void *s) {
  if (!connected) return; 
  try {
		con->refresh((uint) ~(REFRESH_GRANT | REFRESH_STATUS));
		adm_ispis = 1; s_fl_message("refresh succeeded'");
	} catch (BadQuery er){
		adm_ispis = 1; s_fl_alert("refresh failed; error: %s %d ",er.error.c_str(), con->errnum()); return;
	}
}

void ping(Fl_Menu_*m,void *s) {
  if (!connected) return; 
	try {
		con->ping(); adm_ispis = 1; s_fl_message("mysqld is alive");
	} catch (BadQuery er){
		adm_ispis = 1; s_fl_alert("mysqld is gone");
	}
}
