#include <FL/Fl.H>
#include <FL/fl_draw.H>
#include <stdio.h>
#include <stdlib.h>


////////////////////////////////////////////////////////////////

#include <FL/Fl_Window.H>
static void jpeg_exit(Fl_Widget *w, void *p); 

class jpeg_window : public Fl_Window {
	void draw();
	void readtheimage(char *source, int size); // below
	int width;
	int height;
	int depth;
	uchar *ibuffer;
public:
  jpeg_window(char *source, int size,char *title) : Fl_Window(800,600,title)  {
		readtheimage(source,  size);
		Fl::visual(FL_RGB); 
		callback ((Fl_Callback *)jpeg_exit,(void *)this); box(FL_NO_BOX); end(); 
		resize(x(),y(),width,height); show();
	}
	~jpeg_window () { delete[] ibuffer; }
};

static void jpeg_exit(Fl_Widget *w, void *p) { jpeg_window *x = (jpeg_window *)p; delete x;}

void jpeg_window::draw() {
    fl_draw_image(ibuffer,0,0,width,height,depth,0);
}

////////////////////////////////////////////////////////////////

extern void s_fl_alert   (const char *fmt,...);

void jpeg_draw(char *title, char *source, int size) {
  jpeg_window *window = new jpeg_window(source,size,title);
}

////////////////////////////////////////////////////////////////
// Read using jpeg library:

extern "C" {
#include "jpeglib.h"
EXTERN(void) jpeg_mem_src JPP((j_decompress_ptr cinfo, char *src, int size));
}

 void jpeg_window:: readtheimage(char *source, int size) {
  struct jpeg_decompress_struct cinfo;
  struct jpeg_error_mgr jerr;
  cinfo.err = jpeg_std_error(&jerr);
  jpeg_create_decompress(&cinfo);
  jpeg_mem_src(&cinfo, source, size);
  jpeg_read_header(&cinfo, TRUE);
  jpeg_start_decompress(&cinfo);
  width = cinfo.output_width;
  height = cinfo.output_height;
  depth = cinfo.output_components;
  ibuffer = new uchar[width*height*depth];
  uchar *rp = ibuffer;
  //  for (int i=0; i<height; i++) {
  for (int i=height; i--; ) {
    jpeg_read_scanlines(&cinfo, &rp, 1);
    rp += width*depth;
  }
  jpeg_finish_decompress(&cinfo);
  jpeg_destroy_decompress(&cinfo);
}

////////////////////////////////////////////////////////////////
