// generated by Fast Light User Interface Designer (fluid) version 1.00

#include <client.h>
#include <sqlplus.hh>
//
//	This file implements the file I/O routines for the editor engine.
//	These are simple ASCII I/O routines, just for getting text out of
//	a file, or putting it into one.
//
#include "single.h"
#include <FL/vartypes.h>
#include <FL/strings.h>
#include <FL/editor.h>

extern Connection *con;

rclError EditorEngine::LoadSQL(const char *str_query) {
	LastResult = NOERROR;
	bool reallychanged = FALSE; 	// if empty, don't mark as changed
	bool aslast = FALSE;
	long row = Cursor.Row;
	long col = Cursor.Column;
        wString left;            // left and right split of current line
        wString right;   // (if any) for inserting into
        wString s;
	if(CharCount)
		{
			reallychanged = TRUE;
			left = *Lines[Cursor.Row];
		}
	else
		aslast = TRUE;
	if((Cursor.Row >= LineCount-1) || (!CharCount))	// inserting at EOF
		aslast = TRUE;
	left.ChopAt((int)Cursor.Column,&right);	// split current line, insert text
	InsertLine(right, Cursor.Row + 1);		// between two pieces...
	try {
		unsigned int ThisCount;
		Query query = con->query();  query << str_query;
		Result res = query.store(); 
		unsigned int columns =  res.num_fields();  Result::iterator i; int  line = 0;
		for (i = res.begin(); i != res.end(); i++) {
			Row roww = *i;   string strbuf= ""; long unsigned  int *sizes = res.fetch_lengths();
			for (unsigned int counter = 0; counter < columns; counter++) {
				long unsigned int lsize = sizes[counter];
				unsigned int  usize = (unsigned int) lsize; // All this to fool 2.95.1 !!
				string str(roww[counter],usize);
				if  (res.types(counter) == typeid(string))
					escape_string(str);   // C++ variant of Monty's mysql_escape_string
				strbuf +=  str; if (counter < columns -1)  strbuf += options->terminator;
			}	
			s = strbuf.c_str(); s += (char)HARD_RETURN;  ThisCount = s.Length();
			InsertLine(s,++row,aslast);
			if(LastResult == NOMEMORY || LastResult == LIMITS_FULL_ERROR)
				//ShowError(NOMEMORY);
				break;
			if(LastResult != NOERROR)
				break;
		}
		s_fl_message("");
	} catch (BadQuery er){ // handle any connection or query errors that may come up
		adm_ispis = 0; s_fl_alert("Error in querying status: %s %d ",er.error.c_str(), con->errnum()); return LastResult;
	} catch (BadConversion er) {
		adm_ispis = 0; s_fl_alert ("Error: Tried to make impossible conversion"); return LastResult;
	}	
	ReformatParagraph(TRUE,TRUE);
	MoveTo(row,col);
	HasChanged = reallychanged; 	// if was empty, don't mark as changed
	return LastResult;
}

static void exitEditor(Fl_Widget*, void *s);


static Fl_Menu_Item const_menu_edit[] = {
 {"&File", 0,  0, 0, 64, 0, 0, 12, 0},
 {"&New", 0,  (Fl_Callback*)NULL, 0, 0, 0, 0, 12, 0},
 {"&Open", 0,  (Fl_Callback*)NULL, 0, 0, 0, 0, 12, 0},
 {"&Insert File", 0,  (Fl_Callback*)NULL, 0, 128, 0, 0, 12, 0},
 {"&Save", 0,  (Fl_Callback*)NULL, 0, 0, 0, 0, 12, 0},
 {"Save &As", 0,  (Fl_Callback*)NULL, 0, 0, 0, 0, 12, 0},
 {"&Close", 0,  (Fl_Callback*)NULL, 0, 128, 0, 0, 12, 0},
 {"E&xit", 0,  (Fl_Callback*)NULL, 0, 0, 0, 0, 12, 0},
 {0},
 {"&Edit", 0,  0, 0, 64, 0, 0, 12, 0},
 {"Cut", 0,  (Fl_Callback*)NULL, 0, 0, 0, 0, 12, 0},
 {"&Copy", 0,  (Fl_Callback*)NULL, 0, 0, 0, 0, 12, 0},
 {"&Paste", 0,  (Fl_Callback*)NULL, 0, 0, 0, 0, 12, 0},
 {"Top of File", 0,  (Fl_Callback*)NULL, 0, 0, 0, 0, 12, 0},
 {"Read Only", 0,  (Fl_Callback*)NULL, 0, 2, 0, 0, 12, 0},
 {"Browse Mode", 0,  (Fl_Callback*)NULL, 0, 2, 0, 0, 12, 0},
 {0},
 {"&Search", 0,  0, 0, 64, 0, 0, 12, 0},
 {"&Find", 0x40066,  (Fl_Callback*)NULL, (void*)(NULL), 0, 0, 0, 12, 0},
 {"Find &Again", 0xffc0,  (Fl_Callback*)NULL, (void*)(NULL), 128, 0, 0, 12, 0},
 {"&Replace", 0,  (Fl_Callback*)NULL, (void*)(NULL), 0, 0, 0, 12, 0},
 {0},
 {0}
};

class SinisaEditor : public Fl_FancyEditor {
char *filename;
char fname[512];
public:
Fl_Window* MyWindow;
Fl_Menu_Item menu_edit[25];
static void cb_New(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->Clear();
	xx->filename = NULL;
}

static void cb_Open(Fl_Menu_*, void*ss) {
  char *fn;
	SinisaEditor *xx=(SinisaEditor*)ss;
fn = fl_file_chooser("Open File", NULL, NULL);
if(fn)
   {
       FILE *file = fopen(fn, "r");
       if(file)
          {
               xx->Clear();
               strcpy(xx->fname, fn);
               xx->filename = xx->fname;
               xx->LoadFrom(file);
               fclose(file);
          }
      else
          xx->filename = NULL;
   };
}

static void cb_Insert(Fl_Menu_*, void*ss) {
  char *fn;
	SinisaEditor *xx=(SinisaEditor*)ss;
fn = fl_file_chooser("Open File", NULL, NULL);
if(fn)
   {
       FILE *file = fopen(fn, "r");
       if(file)
          {
               strcpy(xx->fname, fn);
               xx->filename = xx->fname;
               xx->LoadFrom(file);
               fclose(file);
          }
      else
          xx->filename = NULL;
   };
}

static void cb_Save(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  if (!xx->filename)
   xx->filename = fl_file_chooser("Save As", NULL, NULL);
if(xx->filename)
    {
        FILE *file = fopen(xx->filename, "w+");
        if(file)
            {
                strcpy(xx->fname, xx->filename);
                xx->filename = xx->fname;
                xx->SaveTo(file);
                fclose(file);
            }
       else
           xx->filename = NULL;
    };
}

static void cb_Save1(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->filename = fl_file_chooser("Save As", NULL, NULL);
if(xx->filename)
    {
        FILE *file = fopen(xx->filename, "w+");
        if(file)
            {
                strcpy(xx->fname, xx->filename);
                xx->filename = xx->fname;
                xx->SaveTo(file);
                fclose(file);
            }
    };
}

static void cb_Close(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->Clear();
xx->filename = NULL;
}

static void cb_E(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  exitEditor(NULL,(void *)xx);
}

static void cb_Cut(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->Cut();
}

static void cb_Copy(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->Copy();
}

static void cb_Paste(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->Paste();
}

static void cb_Top(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->Engine()->MoveTo(0,0);
	xx->SyncDisplay();
}

static void cb_Read(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->readonly(!xx->readonly());
}

static void cb_Browse(Fl_Menu_*, void*ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->browse(!xx->browse());
}


static void cb_Find(Fl_Menu_*, void *ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->Find();
}

static void cb_Find1(Fl_Menu_*, void *ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->FindNext();
}

static void cb_Replace(Fl_Menu_*, void *ss) {
	SinisaEditor *xx=(SinisaEditor*)ss;
  xx->Replace();
}



SinisaEditor (int x, int y, int w, int h) : Fl_FancyEditor (x,y,w,h) 
{
	memset(menu_edit,0,sizeof(menu_edit));
	for (unsigned int i=0; i<23; i++) menu_edit[i]=const_menu_edit[i];
	menu_edit[1].callback_ = (Fl_Callback*)cb_New; menu_edit[1].user_data_=(void *)this;
	menu_edit[2].callback_ = (Fl_Callback*)cb_Open; menu_edit[2].user_data_=(void *)this;
	menu_edit[3].callback_ = (Fl_Callback*)cb_Insert; menu_edit[3].user_data_=(void *)this;
	menu_edit[4].callback_ = (Fl_Callback*)cb_Save; menu_edit[4].user_data_=(void *)this;
	menu_edit[5].callback_ = (Fl_Callback*)cb_Save1; menu_edit[5].user_data_=(void *)this;
	menu_edit[6].callback_ = (Fl_Callback*)cb_Close; menu_edit[6].user_data_=(void *)this;
	menu_edit[7].callback_ = (Fl_Callback*)cb_E; menu_edit[7].user_data_=(void *)this;
	menu_edit[10].callback_ = (Fl_Callback*)cb_Cut; menu_edit[10].user_data_=(void *)this;
	menu_edit[11].callback_ = (Fl_Callback*)cb_Copy; menu_edit[11].user_data_=(void *)this;
	menu_edit[12].callback_ = (Fl_Callback*)cb_Paste; menu_edit[12].user_data_=(void *)this;
	menu_edit[13].callback_ = (Fl_Callback*)cb_Top; menu_edit[13].user_data_=(void *)this;
	menu_edit[14].callback_ = (Fl_Callback*)cb_Read; menu_edit[14].user_data_=(void *)this;
	menu_edit[15].callback_ = (Fl_Callback*)cb_Browse; menu_edit[15].user_data_=(void *)this;
	menu_edit[18].callback_ = (Fl_Callback*)cb_Find; menu_edit[18].user_data_=(void *)this;
	menu_edit[19].callback_ = (Fl_Callback*)cb_Find1; menu_edit[19].user_data_=(void *)this;
	menu_edit[20].callback_ = (Fl_Callback*)cb_Replace; menu_edit[20].user_data_=(void *)this;
}
	
~SinisaEditor()
{
/*	if(MyWindow)
	{
		if (MyWindow->shown()) MyWindow->hide();
		MyWindow->remove(this);	// prevent destructing twice!
		delete MyWindow; MyWindow = (Fl_Window*)0;
	}
*/
}
};

static void exitEditor(Fl_Widget*, void *s) {
	SinisaEditor *p = (SinisaEditor *)s;
	if (p) { 
		Fl_Window *w= p->MyWindow; w->remove(p);
		delete w; w=0;
		delete p; p=0;
	}
}

void  editing_stuff(const char *s) {
  Fl_Window *a = new Fl_Window(406, 340, "Getting SQL results in Editor");
	SinisaEditor *w = new SinisaEditor(3, 23, 399, 312);
	w->box(FL_DOWN_BOX);
	w->color(7); 
	a->resizable(w);
	w->textfont(FL_HELVETICA); if (options->font_number != -1) w->textfont(options->font_number);
	w->textsize(16); w->MyWindow = a;
	w->end(); w->LoadSQL(s);
	Fl_Menu_Bar *o = new Fl_Menu_Bar(-2, -1, 410, 21);
	o->box(FL_THIN_UP_BOX);
	o->menu(w->menu_edit);
	a->callback((Fl_Callback*)exitEditor,(void *)w);
	a->color(246); a->end(); a->show(); 
}
