#include "status.h"
#include <sqlplus.hh>
extern char *pass; extern int w8_x, w8_y;
#include <FL/Fl_Pixmap.H>
#include <FL/Fl_Scroll.H>
#include <FL/Animated_Icon.h>
#include <FL/Fl_Envelope_Scroll.H>
static Fl_Pixmap pixmap_mysql_do_sql(image_mysql_do_sql);
class StatusWindow;

static void polygraph_exit(Fl_Widget *w, void *p);
static void pravi_graph(Fl_Button *w, void *p);

#define MAX_MINUTA 60*24
#define GRAPH_TIMEOUT 60
static float static_hvalues[4] = {0.0,1.0,1.0,1.0};
static float static_vvalues[4] = {0.0,1.0,0.0,1.0};
int  u_koji_sat_je_pocetak;

class single_graph {
	Fl_Window *w;
	Fl_Envelope_Scroll *s;
	class StatusWindow *parent;
	int redni_broj, koliko, minuti; float dy, min_y, max_y,last_y;
	float hvalues[4], vvalues[4]; 
	void change_horisontal (void) {
		float mali = 0.0,  sada = (koliko + minuti)/60.0; if (koliko + minuti < 61) sada = 1.0;
		if (koliko >= MAX_MINUTA) mali = floor(sada - MAX_MINUTA/60);
		hvalues[0] = (sada > 2.0) ?  (floor(sada  - 2.0) + 1.0)  : 0.0;   
		hvalues[1] = 2.0 ;  hvalues[3] = floor(sada + 2.0 - mali);
		hvalues[2] =  mali; //(sada > 2.0) ?  sada - 2.0 : 0.0;
		s->control.hvalue (hvalues[0],hvalues[1],hvalues[2],hvalues[3]);	
	}
	void change_vertical (float f) {
		min_y = s->envelope.ymin(); float position, down;
		if (f < s->envelope.ymin() || ! koliko ) {
			if (f < s->envelope.ymin()) min_y = f; float y;
			if (min_y  > 2.0) {
				y = floor(log10(min_y)) ;  min_y = pow(10.0 , y); 
			} else 
				min_y = 0.0;
			// vvalues[0] = vvalues [2] = (min_y < 100.0) ? 0.0 : min_y; 
		}
		if (f > s->envelope.ymax() || ! koliko) {
			max_y = f; 
			if (max_y  > 2.0) {
				float y = floor(log10(max_y) + 1.0) ;  y = pow(10.0 , y);  max_y = y;  
				if (max_y  < 999.0) dy = max_y/10.0; else dy = max_y / 100.0; 
			} else {
				max_y = 10.0;   dy = 1.0;
			}
		}
		if (f < 10.0) {position = 10.0;  down = 0.0;}
		else {
			float z = f * 1.1;  float y = floor(log10(z));  	y = pow(10.0,y - 1.0);  position = floor(z / y) *y; 
			down = position - dy * 10.0;  
			if (down < 0.0) {position -= down; down = 0.0;}
		}
		vvalues[0] = position; vvalues[1] = dy * 10.0;  vvalues[2] = down; vvalues[3] = max_y;
		s->control.vvalue (vvalues[0],vvalues[1],vvalues[2],vvalues[3]); s->envelope.grid(0.25,dy);
	}
public:
	void add_one (float y) {
		if (koliko >=  MAX_MINUTA) 
			s->envelope.remove_point (0);
		s->envelope.add_point ((float)(koliko + minuti)/60.0,   y/* - last_y*/); 
		change_vertical( y /*- last_y*/ ); change_horisontal();  
		koliko++;  last_y = y;  s->redraw(); 
	}
	single_graph (StatusWindow *par, const char *title, float first_vertical,  int rb, int m) : parent(par), redni_broj(rb), minuti (m)  {
		hvalues = static_hvalues; vvalues = static_vvalues; koliko = 0;  last_y = max_y = min_y = 0.0;
		w = new Fl_Window (450,300);	 w->color (246); w->label(title);   w->callback ((Fl_Callback *)polygraph_exit,(void *)this);
		s = new Fl_Envelope_Scroll (5,5,425,295); 
		s->envelope.grid(0.25,dy); 	s->envelope.snap(1); 	s->envelope.margin (80,20,0,0);	s->margin_adjust();
		add_one (first_vertical);  w->end();   w->show();
	}
	~single_graph (void) {delete w;}
	void kill_it (void) {delete this;}
	int koji_redni_broj (void) { return redni_broj;}
	Fl_Window *koji_window (void) { return w; }
	void crtaj (void) {s->redraw();}
	class StatusWindow *tatica (void) { return parent;}
};

class StatusWindow : public Fl_Window {
	vector <Fl_Output *> outputi; 
	int No_no_no_you_can_not_have_that_type_of_reentrancy; 
public:
	char buffer [65];  vector <string> labele; vector <single_graph *> polygraph;
	StatusWindow (int x, int y, char *s) : Fl_Window (x,y,s) {polygraph.clear(); outputi.clear(); No_no_no_you_can_not_have_that_type_of_reentrancy = 0;}
	void dodaj_graph (int koji) {
		unsigned int counter;
		for (counter = 0; counter < polygraph.size(); counter++)
			if (polygraph[counter]->koji_redni_broj() == koji) break;
		if (counter < polygraph.size()) {
			if (!polygraph[counter]->koji_window()->visible())	polygraph[counter]->koji_window()->show(); else Fl::focus(polygraph[counter]->koji_window());
	  } else {
			u_koji_sat_je_pocetak = 0; int minuti = 0;
			try {
				Connection con(use_exceptions);
				con.real_connect ("",options->hostname.c_str(),options->username.c_str(),\
												(pass) ? pass : "",options->port,options->compress,options->int_timeout,options->socketname.c_str(),0);
				Query qquery=con.query(); qquery << "select curtime()";  Result res = qquery.store();
				if (res.size()) { 
					Result::iterator i=res.begin(); Row row = *i;  
					string s(row[0].get_string(),0,2); u_koji_sat_je_pocetak = atoi(s.c_str());
					string ss(row[0].get_string(),3,2); 	minuti = atoi(ss.c_str());
				}
				single_graph *o = new single_graph (this, outputi[koji]->label(), atof(outputi[koji]->value()),  koji, minuti);
				if (o)  polygraph.insert (polygraph.end(), o);
			} catch (BadQuery er){
				adm_ispis = 1; s_fl_alert("Error in querying curtime(): %s ",er.error.c_str());
			}
		}
	}
	void	dodaj (Fl_Output *x) {outputi.insert(outputi.end(),x);}
  ~StatusWindow (void) {
		outputi.clear(); labele.clear();No_no_no_you_can_not_have_that_type_of_reentrancy=0;
		for (unsigned int counter = 0; counter < polygraph.size(); counter++) 
			polygraph[counter]->kill_it();
		polygraph.clear();
	}
	void cb_b_exitStatus(void) {
		w8_x=x();		w8_y=y();		hide();    delete this;
	}
  void get_me_some_new_values() {
		if (!connected) { hide(); delete this; return;}
		if (No_no_no_you_can_not_have_that_type_of_reentrancy) return;
		No_no_no_you_can_not_have_that_type_of_reentrancy=1;
		try {
			Connection con(use_exceptions);
			con.real_connect ("",options->hostname.c_str(),options->username.c_str(),\
												(pass) ? pass : "",options->port,options->compress,options->int_timeout,options->socketname.c_str(),0);
			Query query = con.query();query << "show status";
			Result res = query.store();
			if (res.size() > 1) {
				int columns =  res.num_fields();  Result::iterator i; unsigned int counter;
				for (i = res.begin(), counter = 0; i != res.end(); i++, counter++) {
					if (counter > outputi.size()) break; 
					Row row = *i; string s(row[1]); Fl_Output *o=outputi[counter]; o->value(s.c_str()); 
				}
			}	else {
				int columns =  res.num_fields();  Result::iterator i = res.begin(); Row row = *i; 
				for (int counter = 0; counter < columns; counter++) {
					string s(row[counter]); Fl_Output *o=outputi[counter]; o->value(s.c_str()); // o->redraw();
				}
			}
			redraw(); 
			for (unsigned int counter = 0; counter < polygraph.size(); counter++) {
				float f = atof(outputi[polygraph[counter]->koji_redni_broj()]->value());
				polygraph[counter]->add_one(f);
			}
			No_no_no_you_can_not_have_that_type_of_reentrancy=0; s_fl_message("");
		} catch (BadQuery er){ // handle any connection or query errors that may come up
			adm_ispis = 1; s_fl_alert("Error in querying status: %s ",er.error.c_str());
			if (this) {hide(); delete this;} return;
		} catch (BadConversion er) {
			adm_ispis = 1; s_fl_alert ("Error: Tried to make impossible conversion");
			if (this) {hide(); delete this;} return;
		}	
	}
};

static void my_timeout_callback(void* v) {
	StatusWindow* p = (StatusWindow*)v;
	p->get_me_some_new_values(); // p->redraw();
	Fl::add_timeout((p->polygraph.size()) ? GRAPH_TIMEOUT : options->update_timeout,my_timeout_callback,v);
}

static void cb_b_update(Fl_Button*, void*s) {
  StatusWindow *p=(StatusWindow *)s;
	p->get_me_some_new_values(); p->redraw();
}

static void s_cb_b_exitStatus(Fl_Button*, void*s) {
	StatusWindow *p = (StatusWindow *)s; Fl::remove_timeout(my_timeout_callback,s);
	p->cb_b_exitStatus(); Fl::remove_timeout(my_timeout_callback,s);
}


void get_status(Fl_Menu_* x, void *y) {
  StatusWindow* w; Animated_Icon *iconE, *iconU;
	if (!connected) return; 
	try {
		Connection con(use_exceptions);
		con.real_connect ("",options->hostname.c_str(),options->username.c_str(),\
											(pass) ? pass : "",options->port,options->compress,options->int_timeout,options->socketname.c_str());
		Query query = con.query();

		query << "show status";
		Result res = query.store();

		{ StatusWindow* o = w = new StatusWindow(543, 399, "Display status");
		o->color(50); o->selection_color(50); o->labeltype(FL_NORMAL_LABEL);  
		o->labelfont(4);   o->callback((Fl_Callback*)s_cb_b_exitStatus,o);
		{ Fl_Box* o = new Fl_Box(15, 5, 515, 25, "Server : %s");
		  o->box(FL_UP_BOX); o->color(214); o->selection_color(214);  o->labeltype(FL_ENGRAVED_LABEL);
			o->labelfont(1); o->labelsize(18);  o->labelcolor(81);
			o->when(FL_WHEN_NEVER);  
			sprintf(w->buffer,"Server : %s", options->hostname.c_str()); o->label(w->buffer);
		}
		{ Fl_Scroll* o = new Fl_Scroll(5, 35, 410, 360);
		  o->type(2);  o->box(FL_UP_BOX);
			o->color(205); o->selection_color(205);  
			if (res.size() > 1) {
				int columns =  res.num_fields();  Result::iterator i; int counter, jj;
				for (i = res.begin(), counter = 0; i != res.end(); i++, counter++) {
					Row row = *i; string s(row[1]); string naziv(row[0]);
					char buffer [65]; sprintf (buffer,"%s :    ",naziv.c_str());
					for (int j = 0; buffer[j];j++) {if (buffer[j] == '_') buffer[j]=' ';}
					string labela(buffer); w->labele.insert(w->labele.end(),labela);
					Fl_Output* o = new Fl_Output(250, 40+counter*25, 125, 25,w->labele[counter].c_str());
					o->labelfont(9);  o->labelsize(18);  o->labelcolor(152); 
					o->textfont(1);  o->textsize(15);  o->textcolor(176); o->value(s.c_str()); 
					for (jj  = 0; (isdigit(s[jj]) || s[jj] == ' ' ) &&  jj < s.length(); jj++) ;
					if (jj == s.length()) {
						Fl_Button *obj = new Fl_Button(10, o->y(),240,o->h()); obj->type(FL_HIDDEN_BUTTON);  
						obj->callback((Fl_Callback *)pravi_graph, (void *) counter);
					}
					w->dodaj(o);
				}
			}	else {
				int columns =  res.num_fields();  Result::iterator i = res.begin();
				Row row = *i; 
				for (int counter = 0; counter < columns; counter++)  { 
					char buffer [65]; sprintf (buffer,"%s :    ",res.names(counter).c_str());
					for (int j = 0; buffer[j];j++) {if (buffer[j] == '_') buffer[j]=' ';}
					string labela(buffer); w->labele.insert(w->labele.end(),labela);
					Fl_Output* o = new Fl_Output(250, 40+counter*25, 125, 25,w->labele[counter].c_str());
					o->labelfont(9);  o->labelsize(18);  o->labelcolor(152); string s(row[counter]);
					o->textfont(1);  o->textsize(15);  o->textcolor(176); o->value(s.c_str()); o->type(2);
					w->dodaj(o);
				}
			}
			o->end(); Fl_Group::current()->resizable(o);
		}
		{ Fl_Box* o = new Fl_Box(420, 200, 120, 35);
		  pixmap_mysql_do_sql.label(o);
		}
		{ Animated_Icon* o = iconE = new Animated_Icon(425, 60, 80, 35);
		    o->box(FL_ROUND_UP_BOX); o->color(213);
			 o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
			 o->add(new Fl_Pixmap(image_sexit0), 1.0);
			 o->add(new Fl_Pixmap(image_sexit1), 1.0); o->set(0);
			 Fl_Button *oo=new Fl_Button(425,60,80,35); oo->box(FL_ROUND_UP_BOX);  oo->down_box(FL_ROUND_DOWN_BOX); 
			 oo->callback((Fl_Callback*)s_cb_b_exitStatus,w); oo->type(FL_HIDDEN_BUTTON);
		}
		{ Animated_Icon* o = iconU = new Animated_Icon(455, 115, 80, 35);
		   o->box(FL_ROUND_UP_BOX); o->color(199);
			o->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
			o->add(new Fl_Pixmap(image_supdate0), options->update_timeout/ 10.0 );
			o->add(new Fl_Pixmap(image_supdate1), options->update_timeout/ 10.0 );
			o->add(new Fl_Pixmap(image_supdate2), options->update_timeout/ 10.0 );
			o->add(new Fl_Pixmap(image_supdate3), options->update_timeout/ 10.0 );
			o->add(new Fl_Pixmap(image_supdate4), options->update_timeout/ 10.0 );
			o->add(new Fl_Pixmap(image_supdate5), options->update_timeout/ 10.0 );
			o->add(new Fl_Pixmap(image_supdate6), options->update_timeout/ 10.0 );
			o->add(new Fl_Pixmap(image_supdate7), options->update_timeout/ 10.0 );
			o->add(new Fl_Pixmap(image_supdate8), options->update_timeout/ 10.0 );
			o->add(new Fl_Pixmap(image_supdate9), options->update_timeout/ 10.0 );
			o->set(0);
			Fl_Button *oo=new Fl_Button(455,115,80,35); oo->box(FL_ROUND_UP_BOX);  oo->down_box(FL_ROUND_DOWN_BOX); 
			oo->callback((Fl_Callback*)cb_b_update,w); oo->type(FL_HIDDEN_BUTTON);
		}
		if ( w8_x || w8_y )
			w->position ( w8_x, w8_y );
		o->end(); 
		Fl::add_timeout(options->update_timeout,my_timeout_callback,w); 
		iconE->start(); iconU->start();
		o->show(); 
		} s_fl_message("");
  } catch (BadQuery er){ // handle any connection or query errors that may come up
		adm_ispis = 1; s_fl_alert("Error in querying status: %s ",er.error.c_str());
		if (w)  {w->hide();  delete w; } return;
  } catch (BadConversion er) {
    adm_ispis = 1; s_fl_alert ("Error: Tried to make impossible conversion");
    if (w) {w->hide(); delete w;} return;
  }
}
static void polygraph_exit(Fl_Widget *w, void *p) {
	class  single_graph *S = (class single_graph  *)p;  S->koji_window()->hide(); 
}
static void pravi_graph(Fl_Button  *o, void *p) {
	class  StatusWindow *S = (class StatusWindow *)(o->parent()->parent());  S->dodaj_graph((int)p);
}
void get_status_b(Fl_Button *, void *) {get_status(NULL,NULL);}
